
## <center> NCID - Net Caller ID Documentation</center>

<center>![NCID](ncid-1.jpg)</center>

<center>Copyright: 2014</center>
<center>Author: John L Chmielewski</center>

<center>Sun Aug 24, 2014</center>

NCID documentation includes information on how to get started,
information on configuring modems, information on configuring
gateways, devices supported, and how to install NCID for the
various operating systems supported.

It also includes some troubleshooting information, an FAQ. and
a TODO.

### <a name="doc_top"></a> Table of Contents

> [Getting Started](#getstarted_top)  
> [Devices Supported](#devices_top)  
> [Modems](#modems_top)  
> [Gateways](#gateways_top)  
> [FAQ](#faq_top)  
> [INSTALL (generic)](#instl_generic_top)    
> [INSTALL-Cygwin](#instl_cygwin_top)  
> [INSTALL-Fedora](#instl_fed_top)  
> [INSTALL-FreeBSD](#instl_free_top)  
> [INSTALL-Mac](#instl_mac_top)  
> [INSTALL-Raspbian](#instl_rasp_top)  
> [INSTALL-Redhat](#instl_red_top)  
> [INSTALL-TiVo](#instl_tivo_top)  
> [INSTALL-Ubuntu](#instl_ubuntu_top)  
> [INSTALL-Win](#instl_win_top)  
> [Verbose Levels](#verbose_top)  
> [Contributors](#contrib_top)  
> [TODO](#todo_top)

## <a name="getstarted_top"></a>Getting Started

> [Table of Contents](#doc_top)

> NCID can be overwhelming for users who have never used it. 
  Current users of NCID are probably not aware of all of its features, 
  or how to use them properly. This document will try to help with 
  those cases.  The [FAQ](#faq_top) should also be of some help.

> In this document:

> - NCID is the package name
> - ncidd is the server name
> - ncid is the client name
> - Unix is a generic term to mean any UNIX-like or Linux-like
    operating system, e.g., Fedora, FreeBSD, Mac OS X, Debian, etc.
> - Uncommenting a line means to remove the **#**

### Getting Started Index

> * [Install the NCID package](#getstarted_pkg)
> * [Configure the ncidd server](#getstarted_cs)
> * [Configure the ncid client](#getstarted_cc)
> * [NCID startup](#getstarted_ns)

### <a name="getstarted_pkg"></a>Install the NCID package

> See the list of 
  [Package Distributions](http://ncid.sourceforge.net/#Distributions).

> SourceForge distributes NCID packages for several operating systems.
  In addition, operating system specific third parties distribute NCID.
  For example, there are Ubuntu and Fedora repositories that include NCID,
  making it easy to install with their package management applications; 
  however, they are not always up-to-date with the latest version at
  SourceForge.

> The first step is to download and install the NCID server and client.
  You can download the NCID packages from sourceforge or a repository
  for your operating system if it is up to date.

> If you are using Fedora, Ubuntu, or Raspbian, NCID is split into
  multiple rpm and deb packages.  The server, gateways, and tools
  are one package.  The client and default output modules are another.

> The Mac tar package and the FreeBSD tar package on sourceforge is the
  complete NCID system.

> There are many distributions based on Redhat or Ubuntu so the Fedora
  or Ubuntu packages may install just fine. (For example, Linux Mint is
  an operating system based on Ubuntu.) Refer to the **INSTALL-"operating
  system"** section for your "operating system".

> If you cannot locate a package, you can download the source, compile,
  and install it.  Refer to the [INSTALL (generic)](#instl_generic_top) section
  of this documentation.

### <a name="getstarted_cs"></a>Configure the ncidd server

> Now that you have installed NCID, you need to configure the method used
  to obtain Caller ID:

  > - [a Caller ID modem connected to a Unix computer](#getstarted_modem)
  > - [the serial NetCallerID device connected to a Unix computer](#getstarted_netc)
  > - [a Caller ID modem on a Windows computer via the NCID YAC 
      (Yet Another Caller ID) gateway](#getstarted_yac)
  > - [VoIP (Voice over Internet Protocol) phones via the NCID SIP 
      (Session Initiation Protocol) gateway](#getstarted_sip)
  > - [Whozz Calling (WC) Ethernet Link network device via the NCID WC 
      gateway](#getstarted_wc)
  > - [an Android smart phone via the NCID Remote Notifier (RN) gateway](#getstarted_rn)


> ####  <a name="getstarted_modem"></a> **Using a modem connected to a Unix computer**

>> Most modern modems support Caller ID but to determine if yours does follow
   the steps below and then refer to [Modem Caller ID Test](#modems_test).

>> The server needs to know which port the modem is on.  You do this
   by editing **ncidd.conf** and either uncomment one of these lines, 
   or add a line with the correct port:

            # The default tty port: /dev/modem
            # set ttyport = /dev/cu.modem # default Mac OS X internal modem
            # set ttyport = /dev/cu.usbmodem24680241 # Mac OS X USB modem (DualComm, Zoom)
            # set ttyport = /dev/ttyS0 # Linux Serial Port 0
            # set ttyport = /dev/ttyACM0 # Linux USB modem 0

>> If you wish to use the hangup feature, you need to uncomment this line:

            # set hangup = 1

>> After modifying **ncidd.conf**, ncidd must be started.

> ####  <a name="getstarted_netc"></a> **Using a serial NetCallerID device connected to a Unix computer**

>> The serial 
   [NetCallerID](http://bedford.nyws.com/BI.asp?Page=CBG/BI/Feb2002/eye.htm#2)
   device is no longer manufactured by Ugotcall, but you can sometimes find 
   it on eBay.

>> Even though it supports Caller ID, the NetCallerID device is not a modem
   and it does not support the NCID hangup feature. Start by hooking it
   up to a serial port and making the changes [above](#getstarted_modem). Once that is completed, 
   make these additional changes to **ncidd.conf**:

>> Uncomment this line:

            # set nomodem = 1

>> Leave this line commented:

            # set hangup = 1

>> After modifying **ncidd.conf**, ncidd must be started.

> ####  <a name="getstarted_yac"></a> **Using a Caller ID modem on a Windows computer via the NCID YAC gateway**

>> You would use the YAC gateway if you are using a YAC server on a
   Windows computer running Microsoft Windows 98 or later.

>> We have a complete section devoted to the YAC gateway. See
   [yac2ncid setup](#gateways_yac)
   in the [Gateways](#gateways_top) topic for more information.

> ####  <a name="getstarted_sip"></a> **Using the SIP Gateway**

>> You would use the sip2ncid gateway if your VoIP phone is using SIP.

>> We have a complete section devoted to the SIP gateway. See
   [sip2ncid setup](#gateways_sip)
   in the [Gateways](#gateways_top) topic for more information.

> ####  <a name="getstarted_wc"></a> **Using the Whozz Calling (WC) gateway**

>> You would use the wc2ncid gateway if you are using a Whozz 
   Calling Ethernet Link device. Serial Whozz Calling units are not
   currently supported.

>> We have a complete section devoted to the WC gateway. See
   [wc2ncid setup](#gateways_wc)
   in the [Gateways](#gateways_top) topic for more information.

> ####  <a name="getstarted_rn"></a> **Using the Android smart phone Remote Notifier (RN) gateway**

>> You would use the rn2ncid gateway if you are using an Android smart phone.

>> We have a complete section devoted to the RN gateway. See
   [rn2ncid setup](#gateways_rn) 
   in the [Gateways](#gateways_top) topic document for more information.

### <a name="getstarted_cc"></a>Configure the ncid client

> Normally the client does not need to be configured, but
  you should review **ncid.conf** to see if you want to change 
  the defaults for displaying the number format, displaying the 
  date format, and ring options if using an output module. There 
  are other changes you can also make.

> After making any changes to **ncid.conf**, start the ncid client.

> **IMPORTANT:** The ncidd server and any needed gateways should
   already be running.

### <a name="getstarted_ns"></a>NCID Startup

> At this point you should have NCID functional. The [INSTALL](#instl_generic_top)
  section for your operating system explains how to make sure NCID is 
  working properly.

> The [INSTALL](#instl_generic_top) section also explains how to start NCID at boot
  and how to manually start the server, gateways, and client.

> If you are having any problems you can ask for assistance in the NCID
  [Help](http://sourceforge.net/p/ncid/discussion/275237/) or
  [Open Discussion](http://sourceforge.net/p/ncid/discussion/275236/) 
  forums on SourceForge.

## <a name="devices_top"></a>Supported Devices

> [Table of Contents](#doc_top)

### Devices Index

> * [Modems](#devices_modem)
> * [ATA (Analog Terminal Adapter)](#devices_ata)
> * [Whozz Calling](#devices_wc)
> * [NetCallerID](#devices_id)

### <a name="devices_modem"></a>Modems

> Any Caller ID serial or USB modem supported by the operating system
  can be used.
  See the [Incomplete list of working modems](#modems_list) in the
  [Modems](#modems_top) section.

> NCID can also use those rare modems that do not support Caller
    ID by configuring *gencid* in **ncidd.conf**, but such modems 
    are limited to the following features:

> - It can only tell you the date and time of the calls.
> - It can be used to hangup the call only when used in conjunction with a
    [Gateway](#gateways_top).

> See the modem [Configuration](#modems_mconf) section for information on
  configuring modems.

### <a name="devices_ata"></a>ATA (Analog Terminal Adapter)

> The ATA hardware is for VoIP (Voice over Internet Protocol).

> VoIP telephone services use an Analog Terminal Adapter, sometimes
  called a VoIP gateway.

> See also [VoIP Info](http://www.voip-info.org/wiki/view/ATA).

> In order to receive Caller ID from VoIP, the local network must be
  configured. Three configurations are considered here:

> - [One device: Cable/DSL Modem with integrated ATA device](#devices_d)
> - [Two devices: Cable/DSL Modem + Router Switch with integrated ATA device](#devices_mr)
> - [Three devices: Cable/DSL Modem + Router Switch + ATA device](#devices_mrd)

> #### <a name="devices_d"></a>One device: Cable/DSL Modem with integrated ATA device
> Many cable companies such as Comcast and Time Warner now offer bundled
   services, referred to in the industry as "triple play service." This
   delivers television, Internet service, and digital phone service via
   a single device.

> The protocol used for the digital phone service is usually proprietary.

> *NCID is not supported in this configuration.*

> #### <a name="devices_mr"></a>Two devices: Cable/DSL Modem + Router Switch    with integrated ATA device
> These router and ATA combo devices may be configured to put the Caller ID 
   on the built-in switch. If you have other routers working, please 
   contribute to this list:

> <pre>
      <b>ROUTER    MODEL      SETTINGS     CONFIGURATION</b>
      ------    -----      --------     -------------
      Linksys  WRTP54G        -         (has "P" in model name)
                                        use Vonage Talk
      Linksys  RT31P2        DMZ        put computer IP address in the DMZ
</pre>

> #### <a name="devices_mrd"></a>Three devices: Cable/DSL Modem + Router Switch + ATA device
> A stand-alone ATA device connected to your network will make its Caller ID
   info (Session Initiation Protocol, or SIP) available to all the other
   network devices that are listening for it. A typical setup has the ATA
   connected to one physical port on the router/switch, and the computer
   running NCID is connected to a different physical port. Most modern
   routers/switches isolate the network traffic on any one physical port
   from all the other physical ports. This is done on purpose to optimize
   network traffic throughput and provide better performance.

> The problem is that having the network traffic isolated in this way does
   not allow the NCID computer to ever receive the Caller ID info from the
   ATA.

> To circumvent this problem, you have several options:

> 1. Use an [Ethernet Tap](http://en.wikipedia.org/wiki/Network_tap).

>     This is the preferred method to obtain Caller ID. The 
      [USB Powered 5-Port 10/100 Ethernet Switch TAP](http://www.dual-comm.com/port-mirroring-LAN_switch.htm)
      by DualComm is a good choice and has been successfully used with NCID.
      The Dualcomm USB powered 5-port Ethernet Switch TAP provides mirrors all
      ethernet traffic on port 1 to port 5.   Simply plug your ATA into port 1
      and your NCID server into port 5. 

>      + The NCID server and ATA need to be (relatively) close together 
      in order to connect directly to the ethernet TAP.
>      + Requires no software configuration beyond the sip2ncid setup.
>      + Requires additional hardware.

> 2. Use [port mirroring](https://en.wikipedia.org/wiki/Port_mirroring).

>     Port mirroring is not port *forwarding*.
      This method requires that your home router be running a 
      Linux-based operating system such as [OpenWRT](https://openwrt.org) or
      [DD-WRT](http://www.dd-wrt.com).

>      + Requires DD-WRT, OpenWRT, or similar OS to be running on your
       home router.
>      + Requires manual configuration of the port mirror on your home router.
>      + Any modification to the firewall rules or QoS settings in DD-WRT 
         will result in the port mirroring commands being discarded; you will
         either have to reboot DD-WRT or manually enter the commands via SSH 
         to restart the port mirror.
>      + The NCID server and ATA can be located anywhere on your home network.
>      + No additional hardware needed.

>             STEPS TO CONFIGURE DD-WRT
>             =========================
>
>             Use ssh to connect to your router and enter the following commands:
> 
>>                iptables -t mangle -A POSTROUTING -d IP-OF-SIP_ATA -j ROUTE --tee --gw IP-OF-NCID-SERVER
>>                iptables -t mangle -A PREROUTING -s IP-OF-SIP_ATA -j ROUTE --tee --gw IP-OF-NCID-SERVER 

>             To verify the port mirror is setup properly, use:

>>                iptables -t mangle -L -v -n

>             Which will provide output that should show something similar to:

>>                Chain PREROUTING (policy ACCEPT 4510K packets, 2555M bytes)
>>                pkts bytes target prot opt in out source destination
>>                ....
>>                219 152K ROUTE 0 -- * * IP-OF-SIP_ATA 0.0.0.0/0 ROUTE gw:IP-OF-NCID-SERVER tee
>>                ....
>>
>>                Chain POSTROUTING (policy ACCEPT 17M packets, 7764M bytes)
>>                pkts bytes target prot opt in out source destination
>>                ....
>>                206 82184 ROUTE 0 -- * * 0.0.0.0/0 IP-OF-SIP_ATA ROUTE gw:IP-OF-NCID-SERVER tee
>>                ....

>             Follow the sip2ncid setup instructions to make sure that SIP packets are being received.
>
>             When everything is working properly, add the port mirroring commands to the DD-WRT 
>             startup commands in the Management tab so that they will be run whenever DD-WRT is rebooted.


> 3. Use [Ettercap](https://en.wikipedia.org/wiki/Ettercap_\(computing\)).

>     Convince your router to send all SIP packets to your NCID server
      and have your NCID server pass the packets on to your ATA.  This is most
      easily and robustly accomplished through the use of [ettercap](http://www.ettercap-project.org).

>     +  If the NCID server or ettercap fails, your router and SIP ATA will
      automatically start communicating directly within a few minutes as the 
      SIP ATA and router are not physically isolated.
>     + The NCID server and ATA can be located anywhere on your home network.
>     + No manual configuration of router is required.
>     + No additional hardware needed.

>             STEPS TO CONFIGURE ETTERCAP
>             ===========================
>
>             Perform these steps from a command prompt on your NCID server.
>
>             To determine the proper INTERFACE for ettercap to use, `ifconfig` will show all available 
>             interfaces. For example, wired ethernet is eth0 and wireless ethernet is wlan0 on Raspbian.

>             Install ettercap if on Ubuntu, Raspbian and other Debian-based systems:

>>                sudo apt-get install ettercap-text-only

>             Install ettercap if on Fedora and other Redhat-based systems:

>>                sudo yum install ettercap

>             Execute ettercap if using IPV6

>>                sudo ettercap -T -D -i <INTERFACE> -M arp:remote /<IP-OF-SIP_ATA>/ /<IP-OF-HOME-ROUTER>/

>             Execute ettercap if using IPV4

>>                sudo ettercap -T -D -i <INTERFACE> -M arp:remote //<IP-OF-SIP_ATA>// //<IP-OF-HOME-ROUTER>//

>             Follow the sip2ncid setup instructions to make sure that SIP packets are being received.

>             You will want to add ettercap to your operating system startup sequence. Steps to do this
>             vary depending on distribution and even depending on the version of a specific distribution.
>             Consult your operating system documentation on how to do this.




> 4.  Use an [Ethernet *hub*](http://en.wikipedia.org/wiki/Ethernet_hubs).
      (Historical, not recommended)

>     Ethernet hubs pre-date
      [Ethernet switches](https://en.wikipedia.org/wiki/Network_switch)
      and do not isolate network traffic between physical ports.  Ethernet
      switches have largely rendered Ethernet hubs obsolete. Some Ethernet
      hubs manufactured today are actually Ethernet switches in disguise.
      See the 
      [hub reference](http://wiki.wireshark.org/HubReference)
      to determine if a hub is really a hub.

> 5. Use a router that supports SIP ALG
      ([Application-level gateway](http://www.voip-info.org/wiki/view/Routers+SIP+ALG)).
      (Historical, not recommended)

>     Unfortunately, not all routers implement ALG correctly. The following
      routers are known to use ALG properly with NCID. If you have other
      routers working, please contribute to this list:

> <pre>
          <b>ROUTER    MODEL      SETTINGS     CONFIGURATION</b>
          ------    -----      --------     -------------
          Linksys   WRT54G        -         (no "P" in model name) 
                                            SIP packets on port 5060 may need a firmware update
                                            if the firmware version is below 1.00.6. 
                                            See http://www.voip-info.org/wiki-Linksys+WRT54G 
                                            for firmware info.
          Linksys   RVS4000    L2 Switch    mirror port #1 to port #2 
                                            assumes gateway is port #1 and NCID SIP gateway is 
                                            monitoring port #2
</pre>

### <a name="devices_wc"></a>Whozz Calling

> A Whozz Calling (WC) Caller ID and Call monitoring unit is used in place
  of one or more modems.  There are various models that all monitor incoming
  calls, and some can monitor outbound as well.

> Only the Whozz Calling Ethernet Link devices are currently supported.
  The serial Whozz Calling units are not.

> See [CallerID.com](http://CallerID.com).

> Refer to the [wc2ncid setup](#gateways_wc) in the 
   [Gateways](#gateways_top) section configure 
   NCID to work with the WC device.

### <a name="devices_id"></a>NetCallerID

> The [NetCallerID](http://bedford.nyws.com/BI.asp?Page=CBG/BI/Feb2002/eye.htm#2)
  device is used in place of a modem. It is no longer manufactured by Ugotcall
  but you can sometimes find it on eBay.

> The ncidd server must be configured to use it.  The server normally
  assumes a modem is going to be used so it must be configured to use
  a serial NetCallerID device that does not use AT commands.

> Uncomment these lines in **ncidd.conf** (this assumes the device is connected
  to serial port 0):

>>      # set ttyport = /dev/ttyS0               # Linux Serial Port 0**
>>      # set ttyspeed = 4800 # NetCallerID port speed**
>>      # set nomodem = 1


> Here are the specifications of the NetCallerID device:

>> ttyport:

>>>      4800 8N1

>> Output Format:

>>>      ###DATE08082225...NMBR14075551212...NAMEJOHN+++\r
>>>      ###DATE...NMBR...NAME   -MSG OFF-+++\r

## <a name="modems_top"></a>Modems

> [Table of Contents](#doc_top)

### Index

> * [NCID Modem Requirements](#modems_specs)
  * [Incomplete list of working modems](#modems_list)
  * [Configuration](#modems_mconf)
  * [Distinctive Ring (DR)](#modems_dr)
  * [Modem Caller ID Test](#modems_test)
  * [Modem Commands that configure Caller ID](#modems_cmds)
  * [Modem Country Codes](#modems_codes)
  * [TiVo Modems](#modems_tivo)

### <a name="modems_specs"></a>NCID Modem Requirements

> NCID requires a modem that supports Caller ID.  The modem must also
  be supported by the Operating System (Linux, FreeBSD, Macintosh).

### <a name="modems_list"></a>Incomplete list of working modems

> * [DualComm Technology USB Adapter/Modem for Caller ID Display](http://www.dual-comm.com/USB\_Caller\_ID\_Modem.htm)
  US Caller ID system - supports Linux

> * Phoebe FAX MODEM, model number CMV1456VQE, serial port external modem
  (uses US Caller ID system)
  supports Linux

> * [Trendnet 56k USB Phone/Internet/Fax Modem TFM-561U](http://www.trendnet.com/products/proddetail.asp?prod=130_TFM-561U)
  supports Linux

> * [TRIXES USB 56K External Dial Up Voice Fax Data Modem Windows 7](http://www.amazon.co.uk/TRIXES-External-Voice-Modem-Windows/dp/B005C4680A)
  UK British Telecom caller id system - supports Linux

> * U.S. Robotics USB modem, part number USR805637, using Fedora and the
  UK British Telecom caller id system

> * [Zoom V.92 56K USB Mini External Modem Model 3095](http://www.zoomtel.com/products/dial_up_external_usb.html)
  supports Linux

> * [LB-LINK BL-UM03B 56K USB2.0 external modem]( http://www.lb-link.cn/index.php/products/view?pid=158)
  supports supports data/fax/TAM operations

### <a name="modems_mconf"></a>Configuration

> The tty port of the modem is set in **ncidd.conf**. If it is not connected
  to the default port /dev/modem, simply uncomment the appropriate *ttyport*
  line:

>>     The default tty port:
>>         /dev/modem

>>     Default Mac OS X internal modem:
>>         set ttyport = /dev/cu.modem

>>     Mac OS X USB modem (DualComm, Zoom):
>>         set ttyport = /dev/cu.usbmodem24680241

>>     Linux Serial Port 0:
>>         set ttyport = /dev/ttyS0

>>     Linux USB modem 0:
>>         set ttyport = /dev/ttyACM0

### <a name="modems_dr"></a>Distinctive Ring (DR)

> From: [DISTINCTIVE RING & MODEMS](http://www.modemsite.com/56k/dring.asp)

> You can find out whether your modem supports DR by connecting to its
  COM port via Windows HyperTerminal (or using the Unix program minicom)
  and issuing the appropriate AT command; if it responds with an "OK", it does, 
  otherwise it does not.
  
> The AT command to enable DR depends on the modem chipset:
> <pre>
<b><u>Chipset</u>                <u>Command</u></b>
3Com/USR/TI            ATS41=1
Rockwell/Conexant      AT-SDR=7
Lucent/Agere           AT+VDR=1,0
</pre>

> Each chipset reports DR differently:

>> 3Com reports ring <u>codes</u>:
>>>       RING A, RING B, RING C

>>Rockwell reports ring <u>codes</u>:
>>>       RING 1, RING 2, RING 3

>> Lucent reports the actual ring <u>cadence</u>
   (the duration of the ringing and the
   silent periods) with DROF/DRON messages.

> As an example, one long ring usually indicates the main phone number, and two short rings usually indicates the first DR phone number. Responses below were generated by two short rings:

> 3Com:
>> RING B

> Rockwell:
>> RING 2

> Lucent:
>> DRON=5  
   DROF=11  
   DRON=5  
   DROF=34

### <a name="modems_test"></a>Modem Caller ID Test

> Start ncidd in debug mode with verbose level 3. You do not need to start 
  any client.

>> **ncidd -Dv3**

> You should get something similar to the following. The important part is the last line: `Modem is fd 4`

>     Started: 05/04/2011 21:48:14
>     Server: ncidd (NCID) 0.81.15  
>     logfile: /var/log/ncidd.log  
>     Command line: ncidd  
>                   -Dv3  
>     Processed config file:/usr/local/etc/ncid/ncidd.conf  
>     Verbose level: 3  
>     Configured to send 'cidlog' to clients.  
>     Configured to send 'cidinfo' to clients.  
>     Processed alias file:/usr/local/etc/ncid/ncidd.alias  
>     Leading 1 from a call required in an alias definition  
>     CID logfile: /var/log/cidcall.log  
>     CID logfile maximum size: 110000 bytes  
>     Data logfile: /var/log/ciddata.log  
>     Telephone Line Identifier: -  
>     TTY port opened: /dev/ttyACM0  
>     TTY port speed: 19200  
>     TTY lock file: /var/lock/lockdev/LCK..ttyACM0  
>     TTY port control signals enabled  
>     CallerID from AT Modem and optional gateways  
>     Handles modem calls without Caller ID  
>     Sent Modem 20 of 20 characters:  
>     AT Z S0=0 E1 V1 Q0  
>     Modem response: 26 characters in 1 read:  
>     AT Z S0=0 E1 V1 Q0  
>     OK  
>     Try 1 to init modem: return = 0.  
>     Modem initialized.  
>     Sent Modem 11 of 11 characters:  
>     AT+VCID=1  
>     Modem response: 17 characters in 1 read:  
>     AT+VCID=1  
>     OK  
>     Modem set for CallerID.  
>     Network Port: 3333  
>     Debug Mode  
>     Not using PID file, there was no '-P' option.  
>     Modem is fd 4

> If you *did* start a client, you will get a line something like:

>     Client 6 from 127.0.0.1 connected, sent call log: /var/log/cidcall.log

> Next, call yourself, and you should see something like:

>     RING  
>     CIDINFO: *LINE*VOIP*RING*1*TIME*21:49:49*  
>     DATE = 0504  
>     TIME = 2149  
>     NMBR = 4075551212  
>     NAME = Chmielewski Joh  
>     CID: *DATE*05042011*TIME*2149*LINE*VOIP*NMBR*4075551212*MESG*NONE*NAME*John*  
>     RING  
>     CIDINFO: *LINE*VOIP*RING*2*TIME*21:49:55*

> Hang up the phone, and a second or two later you should see:

>     CIDINFO: *LINE*VOIP*RING*0*TIME*21:50:02*

> Do a &lt;CTRL-C&gt; to break out and end the test:

>     ^CReceived Signal 2: Interrupt  
>     Terminated: 05/04/2011 21:53:30

> If your modem does not support CID, ncidd will generate a CID line
  on ring 2 to indicate "No Caller ID" by setting the number to "RING"
  and the name to "No Caller ID". You will get something like:

>     RING  
>     CIDINFO: *LINE*VOIP*RING*1*TIME*21:53:02*  
>     RING  
>     CIDINFO: *LINE*VOIP*RING*2*TIME*21:53:08*  
>     CID: *DATE*05042011*TIME*2153*LINE*VOIP*NMBR*RING*MESG*NONE*NAME*No Caller ID*  
>     RING  
>     CIDINFO: *LINE*VOIP*RING*3*TIME*21:53:14*

> If ncidd is configured to not generate a CID line for "No Caller ID" (**ncidd.conf** has *gencid=0*), you
  will get something like:

>     RING  
>     CIDINFO: *LINE*VOIP*RING*1*TIME*21:53:02*  
>     RING  
>     CIDINFO: *LINE*VOIP*RING*2*TIME*21:53:08*  
>     RING  
>     CIDINFO: *LINE*VOIP*RING*3*TIME*21:53:14*

> Hang up the phone, and a second or two later you should see:

>     CIDINFO: *LINE*VOIP*RING*0*TIME*21:53:21*

> Do a &lt;CTRL-C&gt; to break out and end the test:

>     ^CReceived Signal 2: Interrupt  
>     Terminated: 05/04/2011 21:53:30

### <a name="modems_cmds"></a>Modem Commands that configure Caller ID

> **AT#CID=1**

>> Enables Caller ID in USR, Texas Instruments, Rockwell compatible
   modems (excluding software modems and Rockwell HCF),
   Hayes, several Pace modems, PowerBit, GVC, PCTel,
   IDC (VR series) devices, Diamond Supra (Rockwell
   compatible).

> **AT+VCID=1**    
or    
> **AT+FCLASS=8;+VCID=1**

>> Enables Caller ID in all IS-101 modems, Lucent LT, Rockwell
   HCF (V.90 or K56FLEX, e.g. PCI modems from Creative),
   some Pace modems (IS-101 compatible), Multitude,
   IDC, Cirrus Logic, most IDC modems.

> **AT\#CLS=8#CID=1**

>> Enables Caller ID in voice mode on some 56K USR modems, some
   Rockwell compatible (Boca Research, Cardinal, voice Zoom).

> **AT\#CC1**

>> Enables Caller ID on older non-voice Aspen modems, older Cirrus Logic,
   Motorola Voice Surfer, Phoebe.

> **AT\*ID1**

>> Enables Caller ID on some Motorola modems.

> **AT%CCID=1**    
or  
> **AT%CCID=3**

>> Enables Caller ID on Practical Peripherals modems.

> **AT\$JSCID=4,1**    
or    
> **AT\$JSCD=1,0**

>> Enables Caller ID on ELSA ML 56k Internet II (Netherlands) modems.

> **AT#CID=1**   
or    
> **AT+VCID=1**

>> Enables Caller ID on most modems not listed above.

> **AT+FCLASS=8**  
or  
> **AT+FCLASS=8;+VCID=1**  
or    
> **AT-STE=1;+VCID=1**

>> Generic commands to select Active Service Class (Voice Mode) on most
   voice modems.

> **AT+VRID=0**

>> The other AT commands above enable Caller ID *during* an incoming call.
   This command reports the most recently received Caller ID *after* a call
   has completed.  It can sometimes be useful in testing.

### <a name="modems_codes"></a>Modem Country Codes

> #### [U.S. Robotics](http://www.usr.com/support/5631/5631-ug/generic.htm) Country Codes

> This extended syntax command selects and indicates the country of
operation for the modem. It determines the settings for any operational 
parameters that need to be adjusted for national regulations or 
telephone networks.

> #### Syntax

>> **+GCI=CountryCode**

> #### Defined values for supported countries are:
> <pre>
<b><u>Country        Code</u>     <u>Country       Code</u>     <u>Country        Code</u></b>
Austria         0A      Iceland        52      Poland          8A
Belgium         0F      Ireland        57      Portugal        8B
Cyprus          2D      Israel         58      Spain           A0
Czech Republic  2E      Italy          59      Slovakia        FB
Denmark         31      Latvia         F8      Slovenia        FC
Estonia         F9      Liechtenstein  68      Sweden          A5
Finland         3C      Lithuania      F7      Switzerland     A6
France          3D      Luxembourg     69      TBR-21(Default) F6
Germany         42      Malta          B4      Turkey          AE
Greece          46      Netherlands    7B      United Kingdom  B4
Hungary         51      Norway         82       
</pre>
> The factory default is F6 indicating TBR-21.

>TBR-21 is a European telecommunications standard to which all telephone equipment must adhere to, to be allowed connection to Europe's public switched telephone network. It is the default even for U.S. Robotics modems sold in the United States.

> #### Command to report current country code value
>> **+GCI?**

> ###### Command Response:
>     +GCI: CountryCode

> ###### Response Example for France:
>     +GCI: 3D

> #### Command to report all supported country code values
>> **+GCI=?**

> ###### Command Response:
>     +GCI: (CountryCode[,CountryCode][,CountryCode])

> ###### Response Example:
> This indicates the modem has been set for use in the United Kingdom,
> France or Germany.

>     +GCI: (B4,3D,42)

### <a name="modems_tivo"></a>TiVo Modems

> #### TiVo modems supported by NCID:

>   - [External modem connected to the TiVo serial 'headphone' Port (Method #1)](#modems_meth1)
>   - [External modem connected to the TiVo serial 'headphone' Port (Method #2)](#modems_meth2)
>   - [TiVo Series 1 Internal Modem](#modems_tivo1)
>   - [TiVo Series 2 Internal Modem](#modems_tivo2)
>   - [TiVo Series 3 Internal Modem](#modems_tivo3)
>   - [DirecTiVo Internal Modem](#modems_dtivo)

> #### <a name="modems_meth1"></a>External modem connected to the TiVo serial 'headphone' Port (Method #1)

> This method was given by 'nsysblh' in this thread: [Caller-id program for DirecTivo](http://www.dealdatabase.com/forum/showthread.php?p=43465#post43465)

> The modem must be set to ignore DTR *before* attaching it to the TiVo. Hook the modem up to a separate computer and use this string to set DTR:

>> **AT&F0&D0&B1#CID=1&W**

> Wire a cable between the modem and the TiVo as follows:

            Modem DB25        TiVo Headphone Plug
            ----------        -------------------
            pin 2 TD    <---  Tip    (Center)
            pin 3 RD    --->  Ring   (Middle)
            pin 7 Gnd   --->  Ground (Outside) 

> (Pins 3 and 7 are contributed by 'nsysblh'; pin 2 is contributed by an unknown author.)

> #### <a name="modems_meth2"></a>External modem connected to the TiVo 'headphone' serial Port (Method #2)

> This method was given by 'dgrover' in this thread: [Tivo->modem cable](http://archive2.tivocommunity.com/tivo-vb/showthread.php?p=638221&&#post638221)

> Wire a cable between the modem and the TiVo as follows:

            Modem DB25        TiVo Headphone Plug
            ----------        -------------------
            pin 2 TD    <---  Tip    (Center)
            pin 3 RD    --->  Ring   (Middle)
            pin 7 Gnd   --->  Ground (Outside) 

            pin 4 RTS   <--\
            pin 5 CTS   ---/

            pin 6 DSR   ---\
            pin 20 DTR  <--/

> Attach the modem to the TiVo and test it using:

>> **ncidd -D -I AT**

> Call yourself and verify that it works, then &lt;CTRL-C&gt; out of it.

> #### <a name="modems_tivo1"></a>TiVo Series 1 Internal Modem

> The TiVo series 1 internal modem requires the following 
  hardware modification to make it support Caller ID. It was contributed
  by 'ElectricLegs' and drawn by 'Saturn49' in thread 
  [Caller-id program for DirecTivo](http://archive.tivocommunity.com/tivo-vb/showthread.php?postid=500155#post500155).
  Even with this hardware modification, the internal modem does not seem
  to be reliable for Caller ID.

          /-------# #------|47K ohm|-----\
          |       | |                    #
          |14    11 10                1  |
          | | | | | | | | | | | | | | |  ------
          | ---------------------------  | Q3 |
          | |                        *|  ------  
          | |         K2 952          |  |  |
          | |                         |
          | ---------------------------
          | | | | | | | | | | | | | | |
          |15        20               28
          |           |
          |           |      (-)
          \|JUMPER|---#---------| C29 |-

> The #'s are points that will have to be soldered to the TiVo's board.

> #### <a name="modems_tivo2"></a>TiVo Series 2 Internal Modem
> Supports Caller ID

> #### <a name="modems_tivo3"></a>TiVo Series 3 Internal Modem
> Supports Caller ID

> #### <a name="modems_dtivo"></a>DirecTiVo Internal Modem

> Some, maybe most, modems in DirecTivo work with Caller ID.

> This is also in the thread:

> [Caller-id program for DirecTivo](http://archive.tivocommunity.com/tivo-vb/showthread.php?s=&threadid=54469&perpage=20&pagenumber=1)

## <a name="gateways_top"></a>NCID Gateways

> [Table of Contents](#doc_top)

### Gateway Index

> [sip2ncid setup](#gateways_sip)  
  [wc2ncid setup](#gateways_wc)  
  [rn2ncid setup](#gateways_rn)  
  [yac2ncid setup](#gateways_yac)  

### <a name="gateways_sip"></a>sip2ncid setup

> How to setup VoIP Caller ID using sip2ncid.

> ### Sections:

>  [REQUIREMENT](#gateways_sipr)  
   [CONFIGURATION](#gateways_sipc)  
   [TESTING](#gateways_sipt)  
   [START/STOP/RESTART/STATUS/AUTOSTART](#gateways_sips)  

> #### <a name="gateways_sipr"></a>REQUIREMENT:

> VoIP telephone service using SIP.

> Configure your LAN for SIP.  
  See
  <a href="http://nomad.dyndns.org/ncid/doc/NCID_Documentation.html#devices_ata">ATA (Analog Terminal Adapter)</a>

> #### <a name="gateways_sipc"></a>CONFIGURATION:

> The ncidd server defaults to a using a modem to get Caller ID.  if
  you have a standard telephone line (POTS) modem configured, and you
  have at least one VoIP telephone line, all you need to do is 
  start sip2ncid to get Caller ID from VoIP.  The server will handle
  a modem and the sip2ncid gateway easily.

> If you are only using VoIP and do not want to use a modem, you
  need to configure ncidd by uncommenting this line in **ncidd.conf**:

          # set noserial = 1

> This tells ncidd to run without a serial device or modem connected.

> Once you change **ncidd.conf**, you must start/restart ncidd to read it.

> (Note: Do not confuse the *noserial* and *nomodem* settings.
  See [Note 1](#gateways_note1) for an explanation of the differences.)

> Use the sip2ncid `--listdevs` or `-l` option to see your network devices:

          sudo sip2ncid `--listdevs`

> If you are using a DirecTiVo and the command does not return anything, you
  need to load the af_packet kernel module:

          insmod /lib/modules/af_packet.o  
          (http://www.tivocommunity.com/tivo-vb/showthread.php?p=5728255#post5728255)

> #### <a name="gateways_sipt"></a>TESTING:

> To determine if you can receive any network packets, use the `--testall`
  or `-T` option:

          sudo sip2ncid `--testall`

> This will display a packet count and a packet type. It does not know
  all packet types so you may get some UNKNOWN packet types.  It also
  sets debug mode and verbose level 3. You can increase the verbose level
  to see more detail, but if you decrease it below 3, you will not
  see any packets.

> To determine if you can receive SIP data packets, use the `--testudp` or
  `-t` option:
  
          sudo sip2ncid `--testudp`

> This will display SIP packets and what, if anything, it does.  It also
  sets debug mode and verbose level 3.  You can also change the verbose
  level.  If you set verbose to 1, sip2ncid will display lines sent to
  the server instead of the packet contents:
  
          sudo sip2ncid `-tv1`

> If no packets are received in about 45 seconds:

          No SIP packets at port XXXX in XX seconds

> If sip2ncid terminates you should be able to see why and fix it.

> You can get a detailed usage message by executing:

          sip2ncid `--help`

> Sometimes it picks the wrong default interface. If you are using eth0:

          sudo sip2ncid `-ti` eth0

> If you need to see what interfaces are present you can use the
  `--interface` or `-i` option: 

          sudo sip2ncid `--listdevs`

> The display is:

          <interface> : <description>

>  The interface name is everything up to the first space.

> If you do not see any SIP packets, change to port 5061 and try again:

          sudo sip2ncid `--testudp` `--sip :5061`

> You should see something like:

          Network Interface: eth0  
          Filter: port 10000 and udp

> Then about every 20 seconds you should see something like:

          Packet number 1:
          Protocol: UDP  
          SIP/2.0 200 OK  
          Via: SIP/2.0/UDP 70.119.157.214:10000;branch=z9hG4bK-22b185d1  
          From: 321-555-7722 <sip:13215551212@atlas2.atlas.vonage.net:10000>;tag=46f26356c0a3394bo0  
          To: 321-555-7722 <sip:13215551212@atlas2.atlas.vonage.net:10000>  
          Call-ID: fa72d1c2-ead1bdcf@70.119.157.214  
          CSeq: 86785 REGISTER  
          Contact: 321-555-1212 <sip:13215551212@70.119.157.214:10000>;expires=20  
          Content-Length: 0

          Registered Line Number: 13215551212

> The Registered Line Number line will only appear in packet number 1.

> If you do not get the above, you may need to specify an address and/or port
  for sip2ncid to listen for the SIP Invite.  You cannot continue unless you
  get the above.

> If you are using the Linksys RT31P2 Router, you will not see any packets
  unless the computer is in its DMZ (Demilitarized Zone).  Port forwarding 
  the UDP port will not work.  You must set up the DMZ.  If you are using a 
  different VoIP router, try to put the computer in the DMZ and see if that 
  works.  If not, view the SIP tutorial:

> [Configure your home network for SIP-based Caller ID](http://www.files.davidlaporte.org/sipcallerid.html).

> Once you receive the above packets, call yourself.  If you do not get a
  Caller ID message sent to ncidd, you should get an error message saying
  what is wrong.  This has been tested with Vonage and may need tweaking
  for other VoIP service providers.

> If you had Caller ID sent to a client, setup is complete.  You can then
  restart sip2ncid without the test option so it will not display anything.
  You can also set it up to start at boot, along with ncidd.  If any options
  are needed at boot, add them to **sip2ncid.conf**.

> #### <a name="gateways_sips"></a>START/STOP/RESTART/STATUS/AUTOSTART:

> Normally sip2ncid is started using the provided init, service, rc, or
  plist script for your OS. For more information, refer to the 
  [INSTALL](#instl_generic_top) section for your OS.  If none is provided 
  you need to start sip2ncid manually:

          sudo sip2ncid &

> You can also set it up to start at boot, along with ncidd.  If any options
  are needed, add them to **sip2ncid.conf**.

> If sip2ncid did not work, you should have enough information to ask for help.

### <a name="gateways_wc"></a>wc2ncid setup

> How to setup one or more Whozz Calling Ethernet Link (WC) devices for
 Caller ID using wc2ncid.

> #### Sections:

>>  [REQUIREMENT](#gateways_wcr)  
    [CONFIGURATION](#gateways_wcc)  
    [TESTING](#gateways_wct)  
    [START/STOP/RESTART/STATUS/AUTOSTART](#gateways_wcs)  

> #### <a name="gateways_wcr"></a>REQUIREMENT:

> A Whozz Calling Ethernet Link (WC) device (see: http://callerid.com)
  connects to POTS (Plain Old Telephone System) lines and can handle
  2, 4, or 8 lines.  Some models only handle incoming calls while
  others handle incoming and outgoing calls.

> The Whozz Calling user manual tells how to hook up the device.
  You plug your POTS telephone lines into the device and you connect
  the device to your local network.

> #### <a name="gateways_wcc"></a>CONFIGURATION:

> All WC devices must have an IP address within your network in order
  for them to be configured for use by wc2ncid.  This limitation will
  be removed in a future release.  When you try to configure a device
  with an address outside your network, wc2ncid will either give a warning
  or an error message and terminate.  You can then use the wct script to
  change the IP address to one that is in your network.  Use the discover
  option of wct to locate the device:

          wct `--discover`

> The ncidd server defaults to using a modem to get Caller ID.  If
  you have a standard telephone line (POTS) modem configured, you
  can keep the modem and use the WC device to handle additional
  POTS or VoIP lines, or you can replace the modem with the WC device.

> It is recommended that you *not* use a modem so you need to configure ncidd
  by uncommenting this line in **ncidd.conf**:

          # set noserial = 1

> This tells ncidd to run without a serial device or modem connected.

> Once you change **ncidd.conf**, you must start/restart ncidd to read it.

> (Note: Do not confuse the *noserial* and *nomodem* settings.
  See [Note 1](#gateways_note1) for an explanation of the differences.)

> Next, edit **wc2ncid.conf** to configure one or more devices. Look for this
  line:
          wcaddr = 192.168.0.90

>   If your network is on 192.168.0 and the above address is not used,
    you can leave it.  If your network is on 192.168.1 you can set the
    IP address for WC device number 1 (WC-1), for example, by changing the
    line to be:

          wcaddr = 192.168.1.90

>   If you have 2 devices and want to use addresses 192.168.2.90 and
    192.168.2.91, WC device 1 is 192.168.2.90 and WC device 2 is
    192.168.2.91.

          wcaddr = 192.168.2.90, 192.168.2.91

> #### <a name="gateways_wct"></a>TESTING:

> Once you set the IP address for the WC device in **wc2ncid.conf**, start
  wc2ncid and tell it to configure the WC device:

          wc2ncid [`--test`] `--set-wc`

> The `--test` parameter is optional, but it is a good idea to use it so
  wc2ncid does not connect to the NCID server during the configuration
  process.

> If you have 2 or more WC devices, and they are both set to the same
  address or the factory default of 192.168.0.90, you need to change
  both addresses in **wc2ncid.conf**. For example:

          wcaddr = 192.168.0.91, 192.168.0.92

> Turn on one device and execute:

          wc2ncid [`--test`] `--set-wc`

> Terminate wc2ncid with `<CTRL><C>`. Leave the first device turned on, then
  turn on the second device and execute:

          wc2ncid [`--test`] `--set-wc`

> Both devices should be configured and operational.  Terminate wc2ncid
  with `<CTRL><C>`.

> If this is the first time you set wc2ncid up, you should test wc2ncid
  without connecting it to the ncidd server:

          wc2ncid `--test`

> The above command puts wc2ncid in test and debug modes at verbose level 3.
  It will display verbose statements on the terminal, ending with "Waiting
  for calls".  It should show the configured address for each device.
  Test mode prevents wc2ncid from connecting with ncidd.

> If wc2ncid terminates you should be able to see why and fix it.

> You can get a detailed usage message by executing:

          wc2ncid `--help`

> or print out the manual page by executing:

          wc2ncid `--man`

> Call yourself.  You should see more verbose messages as the call is
  processed.  If it looks OK, terminate wc2ncid with `<CTRL><C>`.

> Next, restart wc2ncid in debug mode so it will connect to ncidd:

          wc2ncid `-Dv3`

> Call yourself.  If you do not get a Caller ID message sent to ncidd,
  you should get an error message saying what is wrong.

> If you had Caller ID sent to a client, setup is complete.

> #### <a name="gateways_wcs"></a>START/STOP/RESTART/STATUS/AUTOSTART:

> Normally wc2ncid is started using the provided init, service, rc, or
  plist script for your OS. For more information, refer to the 
  [INSTALL](#instl_generic_top) section for your OS.  If none is provided
  you need to start wc2ncid manually:

          sudo wc2ncid &

> You can also set it up to start at boot, along with ncidd.  If any options
  are needed, add them to **wc2ncid.conf**.

> If wc2ncid did not work, you should have enough information to ask for help.

### <a name="gateways_rn"></a>rn2ncid setup
> How to setup Remote Notifier on an Android smart phone to
  send Caller ID and messages via the rn2ncid gateway.

> #### Sections:

>>  [REQUIREMENT](#gateways_rnr)  
    [CONFIGURATION](#gateways_rnc)  
    [TESTING](#gateways_rnt)  
    [START/STOP/RESTART/STATUS/AUTOSTART](#gateways_rns)  

> #### <a name="gateways_rnr"></a>REQUIREMENT:

>   The smart phone needs to be running Remote Notifier for Android from
    [Google Play](https://play.google.com/store/apps/details?name=org.damazio.notifier&hl=en)

>   Install it and configure it for the address of the computer running
    ncidd.

>   (The main web site for the android-notifier project is located at
    [Google Code](https://code.google.com/p/android-notifier), however,
    you do not need to download anything from there. You only need the
    app from
    [Google Play](https://play.google.com/store/apps/details?name=org.damazio.notifier&hl=en))

> #### <a name="gateways_rnc"></a>CONFIGURATION:

>   The ncidd server defaults to using a modem to get Caller ID.  If
    you have a standard telephone line (POTS) modem configured, you
    can keep the modem and use the rn2ncid gateway.


>   If you do not use a modem and you are not using another gateway,
    you need to configure ncidd by uncommenting this line in **ncidd.conf**:

          # set noserial = 1

> This tells ncidd to run without a serial device or modem connected.

> Once you change **ncidd.conf**, you must start/restart ncidd to read it.

> (Note: Do not confuse the *noserial* and *nomodem* settings.
  See [Note 1](#gateways_note1) for an explanation of the differences.)

> Normally rn2ncid does not need to be configured unless you are using 
  ncid-page to send calls and messages to your smart phone. In that 
  case you need to edit the *reject* line at the end of **rn2ncid.conf** 
  and specify the "from" of SMS/MMS messages to be rejected and not passed
  through to the NCID server. (If you do not do this, the result will be an
  endless loop which could result in excessively high data or text charges
  by your cell phone carrier.) The setting for *reject* is usually of the
  form root@[hostname] where [hostname] is the result of executing the
  Unix `hostname` command on the computer running ncidd.

> For example:

>> **$** hostname  
   smurfzoo.private  
   **$**
   

> Edit **rn2ncid.conf**:

          reject = root@smurfzoo.private

> #### <a name="gateways_rnt"></a>TESTING:

> If this is the first time you set rn2ncid up, you should test rn2ncid
  without connecting it to ncidd.

          rn2ncid `--test`

> The above command puts rn2ncid in test and debug modes at verbose level 3.
  It will display verbose statements on the terminal, ending with
  "Listening at port 10600".  It should show configured options.
  Test mode prevents rn2ncid from connecting with ncidd.

> If rn2ncid terminates you should be able to see why and fix it.

> You can get a detailed usage message by executing:

          rn2ncid `--help`

> or print out the manual page by executing:

          rn2ncid `--man`

> On your smart phone, launch Remote Notifier and choose
  "Send test notification".  rn2ncid should show something like this:

          NOT: PHONE 0123: PING Test notification

> (Note: 0123 is the phone ID and will be different for your phone.)

> If it looks OK, terminate rn2ncid with `<CTRL><C>`.
    
> Next, restart rn2ncid in debug mode so it will connect to ncidd:

          rn2ncid -Dv3

> Do the "Send test notification" again and it should be sent to the server
  and its clients.  If you do not get a "NOT" (short for "NOTIFY") message 
  sent to the server, you should instead get an error message saying what
  is wrong.

> If you had the PING "Test notification" sent to a client, setup is complete.

> #### <a name="gateways_rns"></a>START/STOP/RESTART/STATUS/AUTOSTART:

> Normally rn2ncid is started using the provided init, service, rc, or
  plist script for your OS. For more information, refer to the
  [INSTALL](#instl_generic_top) section for your OS.  If none is provided
  you need to start rn2ncid manually:

          sudo rn2ncid &

> You can also set it up to start at boot, along with ncidd.  If any options
  are needed, add them to **rn2ncid.conf**.

> If rn2ncid did not work, you should have enough information to ask for help.

### <a name="gateways_yac"></a>yac2ncid setup

> How to setup a YAC modem server for Caller ID using yac2ncid.

> #### Sections:

>>  [REQUIREMENT](#gateways_yacr)  
    [CONFIGURATION](#gateways_yacc)  
    [TESTING](#gateways_yact)  
    [START/STOP/RESTART/STATUS/AUTOSTART](#gateways_yacs)  

> #### <a name="gateways_yacr"></a>REQUIREMENT:

> A YAC server on a Windows computer running Microsoft Windows 98 or later.

> Go to the
  [YAC](http://www.sunflowerhead.com/software/yac/) homepage to download 
  the YAC server program. Follow the installation instructions.

> #### <a name="gateways_yacc"></a>CONFIGURATION:

>  Configure the YAC server by giving it the IP address where ncidd is running. 
   Do this by right-clicking the YAC icon in the System Tray, and then select 
   "Listeners...".

>  To configure NCID, uncomment this line in **ncidd.conf**:

          # set noserial = 1

> This tells ncidd to run without a serial device or modem connected.

> Once you change **ncidd.conf**, you must start/restart ncidd to read it.

> (Note: Do not confuse the *noserial* and *nomodem* settings.
  See [Note 1](#gateways_note1) for an explanation of the differences.)

> Normally yac2ncid does not need to be configured, but
  you should review **yac2ncid.conf** to see if you want to change 
  any of its defaults.

> After modifying **ncidd.conf** and **yac2ncid.conf**, you must
  start/restart ncidd first and then the yac2ncid gateway.

> #### <a name="gateways_yact"></a>TESTING:

> Make sure the YAC server is running on the Windows computer.

> Run the yac2ncid gateway with the verbose option:

          yac2ncid `-v`

> Call yourself. If you do not get a Caller ID message sent to ncidd,
  you should get an error message saying what is wrong.

> If you had Caller ID sent to a client, setup is complete. You can 
  then restart yac2ncid without the verbose option so it will not 
  display anything. You can also set it up to start at boot, along
  with ncidd.

> #### <a name="gateways_yacs"></a>START/STOP/RESTART/STATUS/AUTOSTART:

> Normally yac2ncid is started using the provided init, service, rc, or
  plist script for your OS. For more information, refer to the 
  [INSTALL](#instl_generic_top) section for your OS.  If none is provided 
  you need to start yac2ncid manually:

          sudo yac2ncid &

> You can also set it up to start at boot, along with ncidd.  If any options
  are needed, add them to **yac2ncid.conf**.

> If yac2ncid did not work, you should have enough information to ask for help.

<a name="gateways_note1"></a>
Note 1: In **ncidd.conf** there is an important difference between
the settings *noserial* and *nomodem*:

> - You would use *noserial* when you have no serial device connected at all.
> - You would use *nomodem* if you <u>do</u> have a serial device connected
    but it is not a modem. At the present time, the only *nomodem* device known
    to be used with NCID is the [NetCallerID](#gateways_id).

## <a name="faq_top"></a>NCID FAQ

> [Table of Contents](#doc_top)

### FAQ Index

> [General](#faq_gen)

> - [What is Caller ID?](#faq_cid)
> - [What is NCID?](#faq_ncid)
> - [Does NCID only support one client?](#faq_notone)
> - [Can I have multiple servers and clients?](#faq_mult)
> - [Can I run the NCID client under Windows?](#faq_win)
> - [How do I determine if my modem supports Caller ID?](#faq_modem)
> - [What is an NCID gateway?](#faq_gate)
> - [Can NCID be used with YAC (Yet Another Caller ID)?](#faq_yacok)
> - [Does NCID support more than one phone line?](#faq_line)
> - [What packages are distributed?](#faq_pkg)

> [Server](#faq_ser)

> - [What is an "alias" and how do I configure one?](#faq_alias)
> - [What is a "blacklisted" caller and how do I configure one?](#faq_bl)
> - [What is a "whitelisted" caller and how do I configure one?](#faq_wl)
> - [How do I configure NCID to auto hangup on specific calls?](#faq_hup)

> [Gateways](#faq_gw)

> - [How do I configure NCID to use the SIP Gateway?](#faq_sip)
> - [How do I configure NCID to use the YAC (Yet Another Caller ID) Gateway?](#faq_yac)
> - [How do I configure NCID to use the Whozz Calling (WC) Gateway?](#faq_wc)
> - [How do I configure NCID to use the Remote Notifier Gateway?](#faq_rn)

> [Client](#faq_cli)

> - [How many ways does the client display the Caller ID?](#faq_disp)

> [Client Output Modules](#faq_out)

> - [What is an output module?](#faq_mod)
> - [What output modules are available?](#faq_avail)
> - [Can output modules be configured?](#faq_modconf)
> - [How are output modules started?](#faq_modst)
> - [How do I configure the page module to send the CID
    information to my cell phone?](#faq_page)

### <a name="faq_gen"></a>General
- <a name="faq_cid"></a> **What is Caller ID?**

> This is best explained in this
   [Caller ID](http://en.wikipedia.org/wiki/Caller_IDi/)
   article on Wikipedia.

- <a name="faq_ncid"></a> **What is NCID?**

> NCID is a Network Caller ID package that distributes Caller
  ID over a network to a variety of devices and computers.

> NCID consists of:

> + A server (`ncidd`) that normally uses a device to monitor a
    telephone line for CID information.
> + A Universal Client (`ncid`) that obtains the CID information
    from the NCID server and displays it.
> + Multiple gateways that obtain the Caller ID information
    and send it to the NCID server as a CID message.
> + Command line tools that deal with the Whozz Calling (WC) 
    Ethernet Link device, and edit or list the **cidcall.log**, 
    **ncidd.alias**, **ncidd.blacklist**, and **ncidd.whitelist**
    files.

> The Universal Client has output modules that can be used
  to push CID to other computers and devices:

> - TiVo
> - MythTV
> - pager
> - cell phone, using the email-to-SMS gateway of the carrier
> - smartphones and tablets running Android or iOS
> - "speak", using a text-to-speech converter
> - LCD displays

> See the
  [NCID](http://en.wikipedia.org/wiki/NCID)
  article on Wikipedia.

- <a name="faq_notone"></a> **Does NCID only support one client?**

> The NCID package only comes with one client, but other clients
  are available such as `NCIDPop` and `LCDncid`.

> [Third party clients](http://ncid.sourceforge.net/#OtherPackages)
  are also available:

> - Apple iPhone, iPod Touch, iPad
> - Apple Mac OS X
> - GoogleTV and other Android devices
> - GB-PVR, a fully featured Personal Video Recorder (PVR) and media center

- <a name="faq_mult"></a> **Can I have multiple servers and clients?**

> There should only be one server per phone line.

> NCID is designed to have multiple clients.  For example:
  a client on a TiVo, a client on each computer in your
  network, and a client to handle your cell phone.


- <a name="faq_win"></a> **Can I run the NCID client under Windows?**

> The GUI client is the only part of NCID that runs directly under
  Windows.  Output modules are not supported.

> If you want to run the complete NCID distribution, you need to
  install 
  [Cygwin](http://www.cygwin.com).
  You need to configure the NCID server
  so it will only use its gateways to obtain the Caller ID.  If you
  want to use a modem, you need to also install a YAC server.

- <a name="faq_modem"></a> **How do I determine if my modem supports Caller ID?**

> The modem documentation should tell you if the modem supports
  Caller ID and how to set it up.  NCID will try two ways to
  configure a modem for Caller ID, and the configuration file
  (**ncidd.conf**) has other methods you can try.

> NCID documentation has a section called [Modems](#modems_top) that gives
  some information on configuring a modem for Caller ID,
  and there is also a section called [Modem Caller ID Test](#modems_test)
  that tells how to use ncidd to test the modem.

- <a name="faq_gate"></a> **What is an NCID gateway?**

> An NCID gateway obtains the Caller ID information
  and sends it to the NCID server as a CID message. Currently included 
  gateways are:

> - A SIP Gateway that obtains the CID information
    using VoIP SIP packets and sends it to the NCID server.
> - A YAC (Yet Another Caller ID) Gateway that obtains the CID 
    information from a YAC modem server.
> - A [Whozz Calling](http://www.callerid.com/products/ethernet-link/)
   (WC) Ethernet Link device gateway that obtains the CID information 
   from multiple POTS (Plain Old Telephone Service) lines.
> - A gateway for the Android app "Remote Notifier" that obtains smart phone 
    CID and text messages.
> - An NCID-to-NCID Gateway that sends the CID information
    from one or more NCID servers to a selected NCID server.


- <a name="faq_yacok"></a> **Can NCID be used with YAC (Yet Another Caller ID)?**

> Yes. NCID has a YAC output module and a YAC Gateway.

> The YAC output module is used with the NCID client to obtain 
  the CID information from the NCID server and send it to YAC 
  listeners.

> The YAC gateway receives the CID information from a YAC 
  modem server, formats it and sends it to the NCID server 
  as a CID message. If your windows PC has a modem, you can install
  YAC and configure it to send the CID to the YAC Gateway.

- <a name="faq_line"></a> **Does NCID support more than one phone line?**

> Yes, NCID supports one modem or serial device, multiple SIP
  Gateways, multiple YAC Gateways, and multiple [Whozz Calling](http://www.callerid.com/products/ethernet-link/)
  (WC) devices using a WC gateway.

> Each SIP Gateway can support multiple VoIP telephone connections.

> Each WC device can support either 2, 4, or 8 POTS (Plain Old Telephone Service) lines.

- <a name="faq_pkg"></a> **What packages are distributed?**

> - NCID: Package includes a server, client, and gateways.
> - NCID Applet: A Gnome2 applet NCID client.
> - LCDncid: An NCID client that outputs to a LCD display using LCDproc.
> - NCIDPop: An NCID popup client for Mac OS X and Windows.
> - NCIDmod: TivoWebPlus modules for viewing the NCID caller log.
> - OUT2OSD: A TiVo display program used by TiVoCID.

### <a name="faq_ser"></a>Server

- <a name="faq_alias"></a> **What is an "alias" and how do I configure one?**

> An "alias" allows you to replace a generic Caller ID name 
  with a custom one that is more meaningful. You can configure several
  hundred aliases if you want.  Aliases are stored in the **ncidd.alias**
  file.

> For example, if an incoming call has the name "WIRELESS CALLER" you can use
  an alias to change it to the real name of the caller. You would use
  this form of alias:

        alias NAME "FROM" = "TO" if "TELEPHONE_NUMBER"

> Since we do not care what name is there, we will use '\*' in
  the FROM field.  The TO field can contain spaces so in our
  case we want it to say: "John on cell".  The most important
  field is the TELEPHONE_NUMBER; this must match the number
  ncidd receives, and in most cases, it includes a '1', even
  though it is not displayed.  Putting in the values, our alias
  looks like this:

        alias NAME * = "John on cell" if 14075551212

> The complete documentation for aliases is in the **ncidd.alias**
  man page, and as comments in the **ncidd.alias** file.

- <a name="faq_bl"></a> **What is a "blacklisted" caller and how do I configure one?**

> The blacklist is a list of names or numbers that NCID will automatically
  hangup.  The blacklisted names and numbers are stored in the **ncidd.blacklist**
  file.

> The name or number in the blacklist is treated as a substring of the
caller name or number.  For example, using a 10 digit US number:

        3215551212 - will only match 3215551212
        321555     - will match any number with 321555 in it
        ^321555    - will match any number beginning with 321555

> The **ncidd.blacklist** file comes preconfigured for PRIVATE
  names, a spoofing area code, and a few expensive area codes.

> The complete documentation for the blacklist is in the **ncidd.blacklist**
  man page, and as comments in the **ncidd.blacklist** file.

- <a name="faq_wl"></a> **What is a "whitelisted" caller and how do I configure one?**

> The whitelist is a list of names or numbers in the **ncidd.whitelist**
  file.  If a call matches a name or number in the **ncidd.blacklist**
  file, the whitelist file is consulted to see if the call should be
  allowed.

> As an example, the blacklist file comes preconfigured to blacklist
  the entire 999 unused area code.  If you want to allow a specific number
  from area code 999, you would add it to **ncidd.whitelist**:

        9995551212

> You might notice there are 2 entries in the blacklist file for each
  of the blacklisted area codes.  This is because in the US some systems
  have send a leading **1** and some do not.  Not knowing which system a
  user might have, two entries are made to work with both types. Thus
  the above example becomes:

        9995551212 19995551212

> The complete documentation for the whitelist is in the **ncidd.whitelist**
  man page, and as comments in the **ncidd.whitelist** file.

- <a name="faq_hup"></a> **How do I configure NCID to auto hangup on specific calls?**

> The server hangup feature is configured in the "Automatic Call 
  Hangup" section of the **ncidd.conf** file. Just remove the '#' from
  the line:

        # set hangup = 1

> Once you change **ncidd.conf**, you must start/restart ncidd to read it.

> You need to enter the caller name or telephone number in the 
  **ncidd.blacklist** file, usually one name or number per line.

> If there is a match on the name or number when a call comes in,
  it will immediately be terminated. When a call is terminated,
  an "HUP" entry is made in the **ncidd.log** file.

### <a name="faq_gw"></a>Gateways

- <a name="faq_sip"></a> **How do I configure NCID to use the SIP gateway?**

> You need to configure your network, ncidd, and the sip2ncid gateway
  for the ports that SIP Invite uses.

> You can test for network packets in general, or SIP packets
  for a particular port, using sip2ncid.  You would need to
  use the -T|--testall or the -t|--testudp option. Once you
  determine the ports being used, enter them in **sip2ncid.conf**.

> If you have SIP packets on your home network, your network
  is already configured and ready to use.  However, a home network
  may need to be configured to receive SIP packets.
  For a router/phone device you may need to put your computer
  in the Demilitarized Zone (DMZ) to see SIP packets; usually port
  forwarding will not work.  You should also review this tutorial:
  [Configuring your home network for SIP-based callerID](http://www.files.davidlaporte.org/sipcallerid.html)

> If you are using a POTS  (Plain Old Telephone Service) line and SIP,
  no additional ncidd configuration is necessary.  If you are only using
  SIP you need to set *noserial* in **ncidd.conf**. Once you change **ncidd.conf**, 
  you must start/restart ncidd to read it.

- <a name="faq_yac"></a> **How do I configure NCID to use the YAC (Yet Another Caller ID) Gateway?**

> You need to configure ncidd, yac2ncid, and your YAC server.

> If you are using a POTS  (Plain Old Telephone Service) line and
  YAC, no additional ncidd configuration is necessary.  If you are
  only using YAC, or SIP and YAC, you need to set *noserial* in
  **ncidd.conf**. Once you change **ncidd.conf**, you must start/restart ncidd to read it.

> If the YAC server is on the same computer as ncidd,
  no configuration is necessary.  If it is on a different
  computer, the IP address of NCID needs to be inserted
  into the **yac2ncid.conf** file.

> The NCID YAC Gateway is a YAC Listener, so the YAC server
  needs the address IP address of the computer running yac2ncid.

- <a name="faq_wc"></a> **How do I configure NCID to use the Whozz Calling (WC) Gateway?**

> You need a [Whozz Calling](http://www.callerid.com/products/ethernet-link/) Ethernet Link device.
  You can get either a basic or a deluxe 2, 4, or 8 port model. 
  You can configure as many as you would like, in any combination
  of 2, 4, or 8 port units.

> You need to configure ncidd, wc2ncid, and the Whozz Calling device.

> Because the POTS (Plain Old Telephone Service) lines are connected
  directly to the Whozz Calling device, you need to set *noserial* in **ncidd.conf**.
  Once you change **ncidd.conf**, you must start/restart ncidd to read it.

>   If your local network uses 192.168.0.x you do not need to configure
  **wc2ncid.conf**.  If you have a different network, say 192.168.1.x, then you
  need to modify **wc2ncid.conf**:

       Edit wc2ncid.conf:

       change the line: wcaddr = 192.168.0.90
       to: wcaddr = 192.168.1.90

> The wc2ncid gateway script needs to be run at least once before using it with NCID. It also needs to be run whenever you change *wcaddr* in **wc2ncid.conf**.

       wc2ncid --set-wc

> Make sure the Whozz Calling device is set properly. Start wc2ncid in test mode:

       wc2ncid -t

- <a name="faq_rn"></a> **How do I configure NCID to use the Remote Notifier Gateway?**

> You need to install the free 
  [Remote Notifier for Android](https://play.google.com/store/apps/details?id=org.damazio.notifier&hl=en) 
  app from Google Play. 

> You need to configure the Remote Notifier app, ncidd, and rn2ncid.

> Launch Remote Notifier configure the IP address of the computer running
  the NCID server.

> If you are using a POTS (Plain Old Telephone Service) line and Remote 
  Notifier, no additional ncidd configuration is necessary. If you are 
  only using Remote Notifier, set *noserial* in **ncidd.conf**. 
  Once you change **ncidd.conf**, you must start/restart ncidd to read it.

> Normally rn2ncid does not need to be configured unless you are using 
  ncid-page to send calls and messages to your smart phone. In that 
  case you need to edit the *reject* line at the end of the **rn2ncid.conf** 
  file: Specify the "from" of SMS/MMS messages to be rejected and not passed
  through to the NCID server. This is usually an email address dedicated to
  the SMS-to-email service of your carrier.

> Test rn2ncid without connecting it to the ncidd server.

>>  rn2ncid --test

> Choose the Remote Notifier "Send test notification" option.

### <a name="faq_cli"></a>Client

- <a name="faq_disp"></a> **How many ways does the client display the Caller ID?**

> The client receives the Caller ID from the server and displays
  it in one of three ways:

> - Its GUI Window
> - A Terminal Window
> - Using a Output Module

> An output module can also send the information to a smart phone, pager,
  email address, and more.

### <a name="faq_out"></a>Client Output Modules

- <a name="faq_mod"></a> **What is an output module?**

> An output module receives the Caller ID information from the
  ncid client and gives the client new functionality.

> There are various output modules than come with NCID and there
  are also third party ones.

- <a name="faq_avail"></a> **What output modules are available?**

> The following output modules are distributed:

> - ncid-alert: Send NCID call or message desktop notifications.
> - ncid-initmodem: Reinitialize the modem when "RING" is received
    as the number.
> - ncid-kpopup: Uses KDE to create a popup for the Caller ID.
> - ncid-mythtv: Displays the Caller ID on MythTV.
> - ncid-notify: Sends the Caller ID on an iOS device or an Android device.
> - ncid-page: Sends the Caller ID to a cell phone or pager.
> - ncid-samba: Creates a popup for the Caller ID on windows using Samba.
> - ncid-skel: Just echos the Caller ID.  Modify it to write new modules.
> - ncid-speak: Sends the Caller ID to a text-to-speech program.
> - ncid-tivo: Displays the Caller ID on a TiVo.
> - ncid-yac: Sends the Caller ID to YAC clients.
> - ncid-wakeup: Wakeup X-Windows.

- <a name="faq_modconf"></a> **Can output modules be configured?**

> Output modules are configured using files in the conf.d/
  directory.  There will be a separate file for each module
  that needs one, for example, conf.d/**ncid-tivo.conf**.

> For more information, see the comments in the individual files
  in the conf.d/ directory and the man page for each module.

- <a name="faq_modst"></a> **How are output modules started?**

> If you are using Debian, Fedora, Ubuntu, FreeBSD, OSX, or Raspbian
  you would use the OS specific ncid service script to activate
  the service.

> For distributions not based on Debian, Fedora, or BSD the modules
  need to be started manually, Here are three examples:

        ncid --no-gui --program ncid-page &
        ncid --no-gui --program ncid-notify &
        ncid --no-gui --program ncid-speak &

> Each of the above commands start ncid using an output module
  and puts it in the background.
  The first line starts ncid using the page output module.
  The second line starts ncid using the notify output module.
  The third line starts ncid using the speak output module.

- <a name="faq_page"></a> **How do I configure the page module to send the CID information to my cell phone?**

> You need to modify one line in **ncid-page.conf** and maybe one line
  in **ncid.conf**.

> Find this line in **ncid.conf**:

       PageTo=

> *PageTo* needs to be set to your mobile provider SMS e-mail address.
  Here are addresses for the major ones in the US:

       Sprint: phonenumber@messaging.sprintpcs.com
       Verizon: phonenumber@vtext.com
       T-Mobile: phonenumber@tmomail.com
       AT&T: phonenumber@txt.att.net

> For example, if your provider is AT&T and your cell number is 1-321-555-1212,
  then your *PageTo* line becomes:
  <pre>
  PageTo=13215551212@txt.att.net</pre>

> If you want a page anytime the phone rings, you are finished.

> if you only want a page if the phone call is unanswered or is at a certain
  ring count, you need to uncomment the <i>ncid_page</i> line in **ncid.conf**,
  then change the ring count as desired.

> Be careful, all Caller ID devices do not indicate rings. If RING
  is not sent by the modem, a ring count will not work and the page
  will never be sent.

> If you are using a modem, there is no indication of whether the
  the phone was answered or not.  The modem sends RING to ncidd each
  time it gets the ringing signal.  When RING is not sent anymore ncidd
  will indicate the end of ringing.
  A ring count of 4 is a good value to assume the phone was not answered.
  Remove the '#' so you have this line:

        set ncid_page {set Ring 4}

> If you are using SIP, you can configure it to send the page on
  hangup without an answer by modifying the above line to:

        set ncid_page {set Ring -1}

> See the comments in the **ncid.conf** file for more information
  on configuring the ring option line.

## <a name="instl_generic_top"></a>Generic INSTALL and Overview

>  If using sip2ncid, see [sip2ncid setup](#gateways_sip).  
   If using wc2ncid, see [wc2ncid setup](#gateways_wc).  
   If using yac2ncid, see [yac2ncid setup](#gateways_yac).

> [Table of Contents](#doc_top)

### Index

> * [Layout](#instl_generic_layout)
  * [Compile](#instl_generic_compile)
  * [Install](#instl_generic_install)
  * [Test Using a Modem](#instl_generic_modem)
  * [Test Using a Device (like the NetCallerID box)](#instl_generic_device)
  * [Test Using `sip2ncid`](#instl_generic_sip)
  * [Test Using `wc2ncid`](#instl_generic_wc)
  * [Test Using `yac2ncid`](#instl_generic_yac)

### <a name="instl_generic_layout">Layout</a>

* The programs go into `$prefix/bin` and `$prefix/sbin`.
* The config file goes into `$prefix2/etc`.
* The modem link or driver is expected in `$prefix3/dev`.
* The LOG file is expected in `$prefix3/var/log`.
* The man pages go into `$MAN` which is `$prefix/share/man`.
* The defaults are `prefix=/usr/local`, `prefix2=$prefix` and `prefix3=`.

> ####Fedora####
* The init scripts go into `$prefix2/etc/rc.d/init.d`.

> ####Debian, Ubuntu or Raspberry Pi (RPi)####
* The init scripts go into `$prefix2/etc/init.d`.

> ####FreeBSD####
* The rc scripts go into `$prefix2/etc/rc.d`.

> ####Macintosh OSX####
* The plist scripts go into `$(prefix3)/Library/LaunchDaemons`.

### <a name="instl_generic_compile">Compile</a>

>**Note:** The Makefile requires GNU make.
See the top of the Makefile for more information on targets.

* The `libpcap` library and header files must be installed
    to compile the `sip2ncid` gateway.

* Obtain `libpcap` from [TCPDUMP & LIBPCAP](http://www.tcpdump.org/)
  or the package depository of your Linux distribution.
  For example, if your distribution uses yum try:

      `yum install libpcap libpcap-devel`

* To configure programs and config file for /usr/local:

      `make local`

* To compile programs for /usr, and the config file for /etc:

      `make package`

* To compile programs for Fedora:

      `make fedora`

* To compile programs for RHEL (Red Hat Enterprise Linux):

      `make redhat`

* To compile programs for Debian, Ubuntu or Raspberry Pi:

      `make ubuntu`

* To compile programs for Macintosh OSX:

      `make mac` *OR* `make mac-fat`

* To cross-compile for the TiVo:

      `make tivo-s1`  
      (requires TiVo PPC cross-development):  
      `/usr/local/tivo`

      `make tivo-s2`  
      (requires TiVo MIPS cross-development):  
      uses `$(MIPSXCOMPILE)` prefix

### <a name="instl_generic_install">Install</a>

>**Note:** See the top of the Makefile for more information on targets.

* To install in `/usr/local` (man pages go into `/usr/local/share/man`):

      `make install`

* To install in `/usr/local` (man pages go into `/usr/local/man`):

      `make install MAN=/usr/local/man`

* To install programs in `/usr`,  
  config file in `/etc`,  
  and man pages in `/usr/share/man`:

      `make package-install`

      This also works:

      `make install prefix=/usr prefix2=`

* To install programs for Fedora:

      `make fedora-install`

* To install programs for RHEL (Red Hat Enterprise Linux):

      `make redhat-install`

* To install programs for Debian, Ubuntu or Raspberry Pi

      `make ubuntu-install`

* To install programs for Macintosh OSX

      `make mac-install`

### <a name="instl_generic_modem">Test Using a Modem</a>

* Start in this order:  

    `ncidd`  
    `ncid`

    Call yourself.

* If you have problems, start `ncidd` in debug mode:  

        ncidd -D

* To get more information, add the verbose flag:  

        ncidd -Dv3

* To also look at the alias structure:  

        ncidd -Dv9

* The last three lines will be similar to:  

        Modem set for CallerID.  
        Network Port: 3333  
        Wrote pid 20996 in pidfile: /var/run/ncidd.pid

* If ncidd aborts when you call yourself with something like:

        Modem set for CallerID.
        Modem Error Condition. (Phone rang here)
        /dev/ttyS1: No such file or directory

      You need to set `ncidd` to ignore modem signals.
      Uncomment the following line in `ncidd.conf`:

        #set sttyclocal = 1

* You should see the Caller ID lines between the first and second RING.

* If Caller ID is not received from the modem, and if *gencid* is not set
  you will only see RING for each ring.

      If *gencid* is set (the default), you will get a CID at RING number 2:

        07/13/2010 15:21  RING No Caller ID

      This indicates one of three problems:

          The modem is not set for Caller ID
          The modem does not support Caller ID
          The Telco is not providing Caller ID

> Once you solve the problems, restart ncidd normally.

### <a name="instl_generic_device">Test Using a Device (like the NetCallerID box)</a>

* Start in this order:

    `ncidd`  
    `ncid`

    Call yourself.

*  If you have problems, start `ncidd` in debug mode:

      ncidd -D

* To get more information, add the verbose flag:

      ncidd -Dv3

* To also look at the alias structure:

      ncidd -Dv9

* The last three lines will be similar to:

         CallerID TTY port initialized.
         Port: 3333
         pid 20996 in pidfile: /var/run/ncidd.pid

* Once you solve any problems, restart `ncidd` normally.

### <a name="instl_generic_sip">Test Using sip2ncid</a>

* Start in this order:

    `ncidd`  
    `sip2ncid` (review Setup-sip2ncid)  
    `ncid`

    Call yourself.

* If you have problems, start `ncidd` in debug mode:

        ncidd -D

* To get more information, add the verbose flag:

        ncidd -Dv3

* To also look at the alias structure:

        ncidd -Dv9

* The last three lines will be similar to:

        CallerID only from CID gateways
        Network Port: 3333
        Wrote pid 20996 in pidfile: /var/run/ncidd.pid

* Once you solve any problems, restart `ncidd` normally.

### <a name="instl_generic_wc">Test Using wc2ncid:</a>

* Start in this order:

    `ncidd`  
    `wc2ncid` (review Setup-wc2ncid)  
    `ncid`

    Call yourself.

* If you have problems, start `ncidd` in debug mode:

        ncidd -D

* To get more information, add the verbose flag:

        ncidd -Dv3

* To also look at the alias structure:

        ncidd -Dv9

* The last three lines will be similar to:

        CallerID only from CID gateways
        Network Port: 3333
        Wrote pid 20996 in pidfile: /var/run/ncidd.pid`


* Once you solve any problems, restart `ncidd` normally.

### <a name="instl_generic_yac">Test Using yac2ncid</a>

* Start in this order:

    `ncidd`  
    `yac2ncid` (may need to add options)  
    `ncid`

    Call yourself.

 * If you have problems, start `ncidd` in debug mode:

        ncidd -D

 * To get more information, add the verbose flag:

        ncidd -Dv3

 * To also look at the alias structure:

        ncidd -Dv9

* The last three lines will be similar to:

        CallerID only from CID gateways
        Network Port: 3333
        Wrote pid 20996 in pidfile: /var/run/ncidd.pid

* Once you solve any problems, restart `ncidd` normally.

## <a name="instl_cygwin_top"></a>Cygwin TAR Package Install

> If NCID does not work, see [INSTALL](#instl_generic_top) for some simple tests.  

> If using sip2ncid, review [sip2ncid setup](#gateways_sip).

> If using wc2ncid, review [wc2ncid setup](#gateways_wc).

> If using yac2ncid, review [yac2ncid setup](#gateways_yac).

> [Table of Contents](#doc_top)


### Sections:
> [NOTES](#instl_cygwin_note)  
  [INSTALL](#instl_cygwin_inst)  
  [CONFIGURE](#instl_cygwin_conf)  
  [START](#instl_cygwin_st)  
  [REBASE](#instl_cygwin_reb)  
  [RUN AS A QUASI-SERVICE](#instl_cygwin_run)  

### <a name="instl_cygwin_note"></a>NOTES:

> The server has been tested with sip2ncid.

> - The server does not function with a modem so it is configured
    for "noserial".  It requires sip2ncid and yac2ncid to function.
> - the supplied yac2ncid gateway requires YAC to control the modem
    http://search.cpan.org/CPAN/authors/S/SA/SAPER
> - Net-Pcap requires WinPcap: http://www.winpcap.org/
> - The Net-Pcap module has been successfully built under cygwin
> - Latest Versions Tested: WpdPack\_41b.zip and Net-Pcap-0.14.tar.gz

### <a name="instl_cygwin_inst"></a>INSTALL:

> Install WinPcap from http://www.winpcap.org/

> - download WinPcap\_4\_0\_1.exe or later version
> - run WinPcap\_4\_0\_1.exe or later version

> Install Cygwin from http://cygwin.com/

> - download setup.exe into a empty folder
> - Run setup.exe
> - select cygwin download site
> - Let default setup download
> - It is strongly recommended you enable cut and paste in the Cygwin window.
>> - Left click on the icon in upper left
>> - Select Properties
>> - Check Mark the QuickEdit Mode in Edit Options
    
> Install ncid:

> - The NCID package normally installs in /usr/local:
> - If a binary package is available:
  + Copy ncid-VERSION-cygwin.tgz to cygwin, then:
  + tar -xzvf ncid-VERSION-cygwin.tgz -C /
  + EXAMPLE: tar -xzvf ncid-0.64-cygwin.tgz -C /
> - if there is no binary package, you need to compile the source
    (usually not required):

          - Copy ncid-VERSION-src.tar.gz to cygwin, then:
          - tar -xzvf ncid-VERSION-src.tar.gz
          - cd ncid
          - make cygwin
            (compiles for /usr/local, see top of Makefile)
          - make cygwin-install

> If phone system is VoIP and you want to use sip2ncid:

> - nothing else to do

> If you want to use your modem, you need YAC

> - download and install YAC from http://sunflowerhead.com/software/yac/
> - configure the YAC server for a listener at localhost (127.0.0.1)

### <a name="instl_cygwin_conf"></a>CONFIGURE:

> The Makefile configures ncidd.conf for the Cygwin, but you may
   want to change some of the defaults.

> You need to configure sip2ncid to use the Network Interface.
   To find out the network interface name, you need to use the "-l"
   option to sip2ncid.  You should see your Network interface names
   listed.  Select the active one and use it with the "-i" option to
   sip2ncid.

### <a name="instl_cygwin_st"></a>START:

> If this is your first time, you should do
  the [Test Using `sip2ncid`](#instl_generic_sip)
  and [Test Using `yac2ncid`](#instl_generic_yac) procedures in
  the [INSTALL (generic)](#instl_generic_top) section first.

> start the server and clients:

> - ncidd

> If using [sip2ncid](#gateways_sip)

        - sip2ncid -l (list NETWORK_INTERFACES)  
        - sip2ncid -i NETWORK_INTERFACE  

        (Note: display is < INTERFACE : DESCRIPTION >)

> If using [wc2ncid](#gateways_wc):

        - wc2ncid &

> If using [yac2ncid](gateways_yac)

        - yac2ncid &

> If using ncid:

        - ncid &

> Call yourself and see if it works.

### <a name="instl_cygwin_reb"></a>REBASE:

> One of the idiosyncrasies of Cygwin is the need to rebase the dll's
  (set a base dll load address) so they don't conflict and create
  forking errors. The easiest way to do this is documented here:
>> http://cygwin.wikia.com/wiki/Rebaseall
	  
> Just start an ash or dash prompt from \cygwin\bin, and then type
>> rebaseall -v  
   exit
		
### <a name="instl_cygwin_run"></a>RUN AS A QUASI-SERVICE:

> - Don't do this process until you have ncidd and sip2ncid or other processes
    running properly. Once you have things setup though, you can set ncidd and
    sip2ncid to (sort of) run as a service in Windows. I only say "sort of"
    because it's not technically a service, but is called from another
    Cygwin component that is a service.
	  
> - Re-run the setup.exe that you used to install Cygwin, and install the
    cygrunsrv package. It's under Admin

> - Go to a cygwin command line, and type the following to install ncidd as a
    service:

          cygrunsrv -I ncidd -n -p /usr/local/bin/ncidd
                    -f "Network CallerID daemon(ncidd)" -a -D
		 
>> Explaining these parameters:

          -I indicates install  
          -n indicates that the service never exits by itself (I don't
             recall why this has to be set, but it doesn't work otherwise)
          -p /usr/local/bin/ncidd:
             Application path which is run as a service.
          -f "Network CallerID daemon (ncidd)":
             Optional string which contains  the service description
             (the desc you see in the Services listing)
          -a -D: passes the parameter "-D" to the ncidd program so it
                 runs in debug mode. This keeps ncidd running in the
                 "foreground" of the  cygrunsrv process.
		 
> - Likewise, to remove the ncidd service: cygrunsrv -R ncidd
		
> - To install sip2ncid to run in the background, the command line is similar:

          cygrunsrv -I sip2ncid -n -p /usr/local/bin/sip2ncid -y ncidd \  
                    -a '-i "/Device/NPF_{XXXXXXXX-XXXX-XXXX-XXXX-XXXXXXXXXXXX}" \
                    -D' -f "Service to pick SIP packets from network and send to ncidd" \  
                    --termsig KILL
		
>> Explaining these parameters:

		  -I indicates install
		  -n indicates that the service never exits by itself (I don't
             recall why this has to be set, but it doesn't work otherwise)
		  -p /usr/local/bin/sip2ncid: Application path which is run as
             a service.
		  -y ncidd: adds a service dependency with the ncidd service so
             that the ncidd service gets started automatically when you
             start sip2ncid
		  -a '-i "/Device/NPF_{XXXXXXXX-XXXX-XXXX-XXXX-XXXXXXXXXXXX}" -D':
			     note the single and double quotes in this section. You need to
			     replace XXXXXXXX-XXXX-XXXX-XXXX-XXXXXXXXXXXX in the above
			     with NETWORK_INTERFACE from way above. To be clear, you want to
			     replace /Device/NPF_{XXXXXXXX-XXXX-XXXX-XXXX-XXXXXXXXXXXX}
			     with NETWORK_INTERFACE from way above.
		  -f "Service to pick SIP packets from network and send to ncidd":
		     Optional string which contains the service description
			 (the desc you see in the Services listing)
		  --termsig KILL: termination signal to send. If you don't include
		                  this the service doesn't always get stopped.

> - Likewise, to remove the sip2ncid service:

          cygrunsrv -R sip2ncid

> - To install ncid-notify to run in the background, the command
	  line is similar:

          cygrunsrv -I ncid-notify -p /bin/sh.exe -a \
		            '-c "/usr/local/bin/ncid --no-gui --message --program ncid-notify"' \
		            -f "Service to use notify service to send ncid messages to iPad"
		
>> Explaining these parameters:

          -I indicates install
          -p /bin/sh.exe: Application path to run, which in this case is 
             just sh.exe because ncid-notify is a shell script            
          -a '-c "/usr/local/bin/ncid --no-gui  --program ncid-notify"'
                 these are the parameters that get sent to sh.exe:
          -c "/usr/local/bin/ncid: this is the path to the ncid script
          --no-gui: tells ncid not to have a gui
          --program ncid-notify: tells ncid to pass data to "ncid-notify"
          -f "Service to use notify service to send ncid messages to iPad":

>> Optional string which contains the service description
   (the desc you see in the Services listing)

          -y ncidd: you COULD also add this line to add a service dependency
                    with the ncidd service so that the ncidd service gets started
                    automatically when you start ncid-notify. I don't do this,
                    because strictly speaking, you could be running ncidd on a
                    different computer.
			 
> - Likewise, to remove the ncid-notify service: cygrunsrv -R ncid-notify

## <a name="instl_fed_top"></a>Fedora RPM Package Install

> If NCID does not work, see [INSTALL](#instl_generic_top) for some simple tests.  

> If using sip2ncid, see [sip2ncid setup](#gateways_sip).  

> If using wc2ncid, see [wc2ncid setup](#gateways_wc).

> If using yac2ncid, see [yac2ncid setup](#gateways_yac).

> [Table of Contents](#doc_top)

### Sections:

> [COMPILE:](#instl_fed_comp)  
  [INSTALL or UPGRADE:](#instl_fed_iu)  
  [CONFIGURE:](#instl_fed_conf)  
  [FIRST STARTUP:](#instl_fed_fs)  
  [START/STOP/RESTART/RELOAD/STATUS:](#instl_fed_ss)  
  [AUTOSTART:](#instl_fed_as)

### <a name="instl_fed_comp"></a>COMPILE:

> The following package is required:

         sudo yum install libpcap-devel

> See INSTALL for compile instructions

### <a name="instl_fed_iu"></a>INSTALL or UPGRADE:

> NCID requires the server and client RPM packages to function.  The
  server is required on one computer or device, but the client can be
  installed on as many computers as needed.

> The client has a few output modules in its RPM package, and there
  are optional output modules in their own RPM packages.

> Download the server and client RPM packages using yum from the
  Fedora repositories.  You can also download any optional output
  modules you want.

> - List the NCID packages

          sudo yum list ncid\*

> - the most recent versions may be here:

          sudo yum install fedora-release-rawhide  
          sudo yum --enablerepo=rawhide list ncid\*

> - Download the server and client packages:

          sudo yum install ncid-< rpm package >  
          sudo yum install ncid-client-< rpm package >

> - Download any optional module packages wanted:

          sudo yum install ncid-< module rpm package >

> If the current release is not in the Fedora repositories, download
  the RPM packages from https://sourceforge.net/projects/ncid/


> - Download server and client RPM Packages from sourceforge

          ncid RPM Package         (server and gateways)  
          ncid-client RPM Package  (client and default output modules)


> - Download any optional output modules wanted from sourceforge:

          ncid-MODULE RPM Package  (optional client output modules)

> - Install or Upgrade the packages:

         Using the file viewer:
         - Open the file viewer to view the NCID RPM packages
         - Select the RPM packages
         - right click selections and select "Open with Package installer"
         Using YUM:
         - sudo yum install ncid\*.rpm

### <a name="instl_fed_conf"></a>CONFIGURE:

> The ncidd.conf file is used to configure ncidd.

> - The default modem port in ncidd is /dev/modem.  This is just a
    symbolic link to the real modem port. It is probably best to
    set your modem port in ncidd.conf.  This assumes serial port 1:
>> set ttyport = /dev/ttyS0
> - If you are using a Gateway to get the Caller ID instead of a
    local modem, you need to set noserial to 1:
>> set noserial = 1
> - If you are using a local modem with or without a Gateway:
>> set noserial = 0  (this is the default)

### <a name="instl_fed_fs"></a>FIRST STARTUP:

> - If you are running the server and client on the same computer
    and using a modem:

          sudo systemctl start ncidd  
          ncid &

> - If you are running the server and using a SIP gateway:

          sudo systemctl start ncidd sip2ncid  
          ncid &

> - If you are running the server and using a Whozz Calling gateway:

          sudo systemctl start ncidd wc2ncid  
          ncid &

> - If you are running the server and using a YAC gateway:

          sudo systemctl start ncidd yac2ncid
          ncid &

> - Call yourself and see if it works, if not,

>> stop the gateway and server:  

          sudo systemctl stop sip2ncid ncidd  

>> and continue reading the test sections.

> - If everything is OK, enable the NCID server, gateways, and
    client modules you are using, to autostart at boot.

>> For example, to start ncidd and sip2ncid at boot:

          sudo systemctl enable ncidd sip2ncid

>> The GUI ncid client must be started after login, not boot.

>> NOTE:
>>> ncid normally starts in the GUI mode and there is no
    ncid.service script to start or stop it.  There are
    service scripts for starting ncid with output modules,
    for example: ncid-page, ncid-kpopup, etc.

### <a name="instl_fed_ss"></a>START/STOP/RESTART/RELOAD/STATUS:

> Use the 'systemctl' command to start any of the daemons.  The service
  commands are: start, stop, restart, reload, reload-or-restart, and status.
  The client can also be started using the output module name instead
  of ncid.  All output modules can be run at the same time.

> Here are some examples:

> - start the NCID server:

          sudo systemctl start ncidd.service

> - stop the ncid2sip server:


> - reload the server alias file:

          sudo systemctl reload-or-restart ncidd.service

> - restart ncid using ncid-page:

          sudo systemctl restart ncid-page.service

> - get the status of ncid using ncid-speak:

          sudo systemctl status ncid-speak.service

> Review the man page (man systemctl).

### <a name="instl_fed_as"></a>AUTOSTART:

> Use the 'systemctl' command to enable/disable a service to start at boot.

> Here are some examples:

> - autostart ncidd at boot:

          sudo systemctl enable ncidd

> - autostart ncidd and sip2ncid at boot:

          sudo systemctl enable ncidd sip2ncid

> - remove ncid-speak from starting at boot:

          sudo systemctl disable ncid-speak

> Review the manpage (man systemctl).

## <a name="instl_free_top"></a>FreeBSD TAR Package Install

> If NCID does not work, see [INSTALL](#instl_generic_top) for some simple tests.  

  If using sip2ncid, see [sip2ncid setup](#gateways_sip).

  If using wc2ncid, see [wc2ncid setup](#gateways_wc).

  If using yac2ncid, see [yac2ncid setup](#gateways_yac).

> [Table of Contents](#doc_top)

### Sections:

> [COMPILE:](#instl_free_comp)  
  [INSTALL:](#instl_free_inst)  
  [CONFIGURE:](#instl_free_conf)  
  [STARTUP:](#instl_free_start)  
  [START/STOP/STATUS:](#instl_free_ss)  
  [AUTOSTART:](#instl_free_as)  
  [TRIMMING LOG FILES:](#instl_free_trim)  
  [GMAKE NOTE:](#instl_free_note)  

### <a name="instl_free_comp"></a>COMPILE:

> - See INSTALL

### <a name="instl_free_inst"></a>INSTALL:

> - install tcl/tk

> - make sure tcl calls tcl?.? and wish calls wish?.?,
    otherwise modify the TCLSH and WISH variables in ncid

> - The NCID package installs in /usr/local:

> - install the NCID binary package if available:

          Copy ncid-VERSION.freebsd.tgz to the FreeBSD computer, then:
          tar -xzvf ncid-VERSION-freebsd.tgz -C /
          EXAMPLE: tar -xzvf ncid-0.64-freebsd.tgz -C /

> -  compile and install from source if no binary package:

          Copy ncid-VERSION-src.tar.gz to the FreeBSD computer, then:
          tar -xzvf ncid-VERSION-src.tar.gz
          gmake freebsd (compiles for /usr/local, see top of Makefile)
          gmake freebsd-install

### <a name="instl_free_conf"></a>CONFIGURE:

> The ncidd.conf file is used to configure ncidd.

> - The default modem port in ncidd is /dev/modem.  This is just a
     symbolic link to the real modem port.

> - You should set the modem in ncidd.conf, if you are not using
     /dev/modem.  Use one of cuaa0, cuaa2, cuaa3, cuaa4 in /dev which
     corresponds to COM1, COM2, COM3, COM4

> - If you are using COM1 then you would add this line to ncidd.conf:  

          set modem = /dev/cuaa0

> - If you are using a gateway instead of a local modem,
    you need to set noserial to 1:  

          set noserial = 1

> - If you are using a local modem with or without a gateway:  

          set noserial = 0  (this is the default)

### <a name="instl_free_start"></a>STARTUP:

> - If you are running the server and client on the same computer
     and using a modem:  

          /usr/local/etc/rc.d/ncidd onestart  
          ncid &

> - If you are running the server and using a SIP gateway:  

          /usr/local/etc/rc.d/rc.d/ncidd onestart  
          /usr/local/etc/rc.d/rc.d/sip2ncid onestart  
          ncid &

> - If you are running the server and using a Whozz Calling gateway:  

          /usr/local/etc/rc.d/rc.d/ncidd onestart  
          /usr/local/etc/rc.d/rc.d/wc2ncid onestart  
          ncid &

> - If you are running the server and using a YAC gateway:  

          /usr/local/etc/rc.d/rc.d/ncidd onestart  
          /usr/local/etc/rc.d/rc.d/yac2ncid onestart  
          ncid &

> - Call yourself and see if it works, if not:

>> + stop the gateway used:  

              /usr/local/etc/rc.d/rc.d/sip2ncid onestop

>> + stop the server:  

              /usr/local/etc/rc.d/rc.d/ncidd onestop

>> + and continue reading the test sections.

> - If everything is OK, enable the NCID server, gateways, and
    client modules you are using to autostart at boot:

> - NOTE:  

>> - The ncid client normally starts in the GUI mode and there is no
     ncid.rc script to start or stop it.

>> - There are rc.d scripts for starting ncid with output modules,
     for example: ncid-page, ncid-kpopup, etc.

### <a name="instl_free_ss"></a>START/STOP/STATUS:

>  The /usr/local/etc/rc.d/ncid\* scripts to start any of the daemons.
   The rc.d commands are: start, stop, restart, reload, and status.  The
   client can also be started using the output module name instead of ncid.
   All output modules can be run at the same time.

> Here are examples:

        sudo /usr/local/etc/rc.d/ncidd start  
        sudo /usr/local/etc/rc.d/ncidd reload  
        sudo /usr/local/etc/rc.d/sip2ncid restart  
        sudo /usr/local/etc/rc.d/ncid-speak stop  
        sudo /usr/local/etc/rc.d/ncid-page status  
        sudo /usr/local/etc/rc.d/ncid-kpopup rcvar

> If a service is not enabled, you must prefix 'one' to the commands;
  start becomes onestart, stop becomes onestop, and so forth.

### <a name="instl_free_as"></a>AUTOSTART:

> - If you want NCID services to start automatically at boot, you need to
    add an enable line /etc/rc.conf.local for each service you want started.
    If /etc/rc.conf.local does not exist, create it.

> - Here is the list of rc scripts and their enable lines:

                /usr/local/etc/rc.d/     /etc/rc.conf.local
                --------------------     ------------------
                ncidd                    ncidd_enable="YES"
                sip2ncid                 sip2ncid_enable="YES"
                yac2ncid                 yac2ncid_enable="YES"
                ncid-kpopup              ncidkpopup_enable="YES"
                ncid-notify              ncidnotify_enable="YES"
                ncid-page                ncidpage_enable="YES"
                ncid-samba               ncidsamba_enable="YES"
                ncid-skel                ncidskel_enable="YES"
                ncid-speak               ncidspeak_enable="YES"
                ncid-yac                 ncidyack_enable="YES"

### <a name="instl_free_trim"></a>TRIMMING LOG FILES:

> - FreeBSD uses newsyslog by default to trim files. To trim the
    cidcall.log and the ciddata.log files, add this entry to
    /etc/newsyslog.conf:  

          /var/log/cid\*.log   root:wheel 644 5 * $M1D0 GN

### <a name="instl_free_note"></a>GMAKE NOTE:

> - The NCID source package requires gmake.

> - GNU getopt is installed from /usr/ports/devel/libgnugetopt:  

          cd /usr/ports/devel/gmake
          make all install

## <a name="instl_mac_top"></a>Macintosh TAR Package Install

> If NCID does not work, see [INSTALL](#instl_generic_top) for some simple tests.  

> If using sip2ncid, see [sip2ncid setup](#gateways_sip).  
  If using wc2ncid, see [wc2ncid setup](#gateways_wc).  
  If using yac, see [yac setup](#gateways_yac).

> [Table of Contents](#doc_top)

### Sections:

> [SYSTEM REQUIREMENTS:](#instl_mac_sr)  
  [COMPILE:](#instl_mac_comp)  
  [INSTALL or UPGRADE:](#instl_mac_iu)  
  [CONFIGURE:](#instl_mac_conf)  
  [FIRST STARTUP:](#instl_mac_fs)  
  ([AUTO)START/STOP:](#instl_mac_ss)  
  [CHECKING DAEMON STATUS:](#instl_mac_check)  
  [TRIMMING LOG FILES:](#instl_mac_trim)  

### <a name="instl_mac_sr"></a>SYSTEM REQUIREMENTS:

> NCID should work on Mac OS X 10.4 (Tiger) and later versions, using both 
  PowerPC (PPC) and Intel processors.
     
> In order to use the NCID GUI client on Mac OS X 10.4 (Tiger) and 10.5
  (Leopard), you must install ActiveTcl because the NCID GUI client requires
  the new tcl/tk "tile" package.

> Furthermore, you must install a patch after
  ActiveTcl is installed to prevent a "BGError: bad attribute" error from
  occuring when you try to change the font. See instructions under the
  FIRST STARTUP section.
     
> Mac OS X 10.6 (Snow Leopard) was unavailable for testing.
     
### <a name="instl_mac_comp"></a>COMPILE:

> See INSTALL

### <a name="instl_mac_iu"></a>INSTALL or UPGRADE:

> NCID requires the server and at least one client to function. The
  server is required on one computer or device, but the client can be
  installed on as many computers as needed.

> #### Install ncid:

> - The NCID package normally installs in /usr/local.

> - Install the NCID binary package if available:

          Copy ncid-VERSION.mac-osx.tgz to the Mac
          sudo tar -xzvf ncid-VERSION-mac-osx.tgz -C /

          EXAMPLE: sudo tar -xzvf ncid-0.64.mac-osx.tgz -C /

> - Compile and install from source if there is no binary package:

          Copy ncid-VERSION-src.tar.gz to the Mac
          tar -xzvf ncid-VERSION-src.tar.gz
          cd ncid
          make mac (compiles for /usr/local, see top of Makefile)
          sudo make mac-install
                        
> #### Upgrade ncid:

> - The NCID package normally installs in /usr/local and configuration
    files are normally in /usr/local/etc/ncid.
          
> - If a binary package is available:

>> Extracting the tar file will REPLACE the contents of all of
   the NCID configuration files. Be sure to back them up first.
   This includes all files in /usr/local/etc/ncid/.

> - Copy ncid-VERSION.mac-osx.tgz to the Mac, then:

          sudo tar -xzvf ncid-VERSION-mac-osx.tgz -C /

          EXAMPLE: sudo tar -xzvf ncid-0.64.mac-osx.tgz -C

> - You will need to manually compare your backed up configuration
    files with the new ones, and manually edit any differences.
                
> - If there is no binary package, you need to compile the source.
    Your existing configuration files will be preserved, and new ones
    installed will have .new as the extension.
            
> - Copy ncid-VERSION-src.tar.gz to the Mac, then:

          tar -xzvf ncid-VERSION-src.tar.gz
          cd ncid
          make mac (compiles for /usr/local, see top of Makefile)
          sudo make mac-install

> - You will need to manually compare your current configuration
     files with the ".new" ones, and manually edit any differences.
                                
### <a name="instl_mac_conf"></a>CONFIGURE:

> The Makefile preconfigures ncidd.conf for the Mac, but you may
  want to change some of the defaults.

> - If you are using a gateway instead of a local modem,
    you need to set noserial to 1:

          set noserial = 1

> - If you are using a local modem with or without a gateway

          set noserial = 0  (this is the default)

### <a name="instl_mac_fs"></a>FIRST STARTUP:

> - If you are running Mac OS X 10.4 (Tiger) or 10.5 (Leopard) go to this site
    and download ActiveTcl version 8.4.19.6 for the Mac:
    http://www.activestate.com/activetcl/downloads
      
> - After downloading, double-click on the file:

          ActiveTcl8.4.19.6.295590-macosx-universal-threaded.dmg

> - Then double-click on the icon where it says, "ActiveTcl-8.4.pkg"
    and follow the instructions.
      
> - Finally, install the patch for ActiveTcl 8.4.19.6 by launching Terminal
    and typing:

          sudo /usr/local/share/doc/ncid/fix-combobox

> - If you are running the server and client on the same computer
    and using a modem:  

          In Terminal, type: sudo /usr/local/sbin/ncidd  
          In Finder, navigate to the Applications folder and double-click on "ncid-gui".
          Close the front Terminal window that says, "Completed Command" in the title bar.

> - If you are running the server and using a SIP gateway:
    + In Terminal, type:
        sudo /usr/local/sbin/ncidd
        sudo /usr/local/sbin/sip2ncid
    + In Finder, navigate to the Applications folder and double-click on "ncid-gui".
    + Close the front Terminal window that says, "Completed Command" in the title bar.
    <br><br>

> - If you are running the server and using a YAC gateway:
    + In Terminal, type: sudo /usr/local/sbin/ncidd
    + In Terminal, type: sudo /usr/local/sbin/yac2ncid
    + In Finder, navigate to the Applications folder and double-click on "ncid-gui".
    + Close the front Terminal window that says, "Completed Command" in the title bar.
    <br><br>

> - Call yourself and see if it works. If not,
      stop the gateway first (if used), and then stop the server,
      using 'sudo kill' and the appropriate process ID.
      Continue by reading the test sections.

> - If everything is OK, enable the NCID server, gateways, and
      client modules you are using, to autostart at boot.

### <a name="instl_mac_ss"></a>(AUTO)START/STOP:
              
> #### SERVER
    
>> Under Mac OS X 10.4 and later, the mechanism used to start the NCID
   server processes is 'launchd' and requires 'plist' files in
   /Library/LaunchDaemons. Appropriate plist files for the NCID server
   processes are created automatically when NCID is installed, however,
   they must be manually activated.
    
>> Once activated, no action is typically required as the plist files are 
   configured to automatically start each time the system boots.
    
>> Here is the complete list of plist files:
    
          /Library/LaunchDaemons/net.sourceforge.ncid-initmodem.plist  
          /Library/LaunchDaemons/net.sourceforge.ncid-notify.plist  
          /Library/LaunchDaemons/net.sourceforge.ncid-page.plist  
          /Library/LaunchDaemons/net.sourceforge.ncid-samba.plist  
          /Library/LaunchDaemons/net.sourceforge.ncid-speak.plist  
          /Library/LaunchDaemons/net.sourceforge.ncid-yac.plist  
          /Library/LaunchDaemons/net.sourceforge.ncid2ncid.plist  
          /Library/LaunchDaemons/net.sourceforge.ncidd.plist  
          /Library/LaunchDaemons/net.sourceforge.sip2ncid.plist  
          /Library/LaunchDaemons/net.sourceforge.wc2ncid.plist  
          /Library/LaunchDaemons/net.sourceforge.yac2ncid.plist
    
>> You do not interact with launchd directly, instead you use the 'launchctl'
   command line utility.

>> You should only activate the NCID servers and client modules you need. 
   Activating will also start the process immediately; there is no need
   to reboot.

>> The syntax for stopping the daemons is the same as starting them, except
   you use the 'unload' command instead of the 'load' command. Doing an unload
   stops the daemon immediately and prevents it from starting automatically
   the next time the system is booted.
    
>> Here are some examples:

>> - start the NCID server:  

              sudo launchctl load -w /Library/LaunchDaemons/net.sourceforge.ncidd.plist

>> - stop the sip2ncid server:  

              sudo launchctl unload -w /Library/LaunchDaemons/net.sourceforge.sip2ncid.plist

>> - start ncid with ncid-page  

              sudo launchctl load -w /Library/LaunchDaemons/net.sourceforge.ncid-page.plist
      
>> Review the man page (man launchctl).

> #### CLIENT:
    
>> For the NCID GUI client, no .plist is currently provided because of the 
   requirement that NCID must be installed as root, and the GUI preference file
   is specific to each user. However, a script called "ncid-gui" is installed
   for you automatically to the Applications folder. To have it start when you 
   automatically log in, drag "ncid-gui" to your account's Login Items as
   described here: http://support.apple.com/kb/HT2602
    
>> After you login, you should close the front Terminal window that says, 
    "Completed Command" in the title bar.
        
### <a name="instl_mac_check"></a>CHECKING DAEMON STATUS:

> Use the launchctl 'list' command to show the daemons currently loaded, 
  optionally using fgrep to filter out only NCID related processes.
    
> Daemons currently running will have a process id.
    
> Daemons which were stopped without an error will not be listed at all.
    
> If a daemon has stopped due to an error, it will have no process id but 
  will have a numeric exit status. Examine the contents of the
  /var/log/system.log file to determine the problem. Once you fix the 
  problem, use the launchctl 'unload' command followed by the 'load' command.

> Example:  sudo launchctl list|fgrep net.sourceforge.ncid
    
            PID     Status  Label
            422     -       net.sourceforge.ncid-notify
            419     -       net.sourceforge.ncidd

### <a name="instl_mac_trim"></a>TRIMMING LOG FILES:

> The Mac uses newsyslog to trim files. To trim the cidcall.log and the
  ciddata.log files, add this entry to /etc/newsyslog.conf

        /var/log/cid\*.log   root:wheel 644 5 * $M1D0 GN

## <a name="instl_rasp_top"></a>Raspbian Install

### [Raspberry Pi][] DEB Package Install using [Raspbian OS][]

[Raspberry Pi]: http://www.raspberrypi.org/
[Raspbian OS]: http://www.raspbian.org/

> If NCID does not work, see [INSTALL](#instl_generic_top) for some simple tests.  

  If using sip2ncid, see [sip2ncid setup](#gateways_sip).  
  If using wc2ncid, see [wc2ncid setup](#gateways_wc).  
  If using yac2ncid, see [yac2ncid setup](#gateways_yac).

> [Table of Contents](#doc_top)

### Sections:

> [COMPILE:](#instl_rasp_comp)  
   [INSTALL or UPGRADE:](#instl_rasp_iu)  
   [CONFIGURE:](#instl_rasp_conf)  
   [FIRST STARTUP:](#instl_rasp_fs)  
   [START/STOP/RESTART/RELOAD/STATUS:](#instl_rasp_ss)  
   [AUTOSTART:](#instl_rasp_as)  

### <a name="instl_rasp_comp"></a>COMPILE:

> The following packages are required:

          sudo apt-get install libpcap0.8\*
    
> See INSTALL for compile instructions

### <a name="instl_rasp_iu"></a>INSTALL or UPGRADE:

> NCID requires the server and client DEB packages to function.  The
  server is required on one computer or device, but the client can be
  installed on as many computers as needed.

> The client has a few output modules in its DEB package, and there
  are optional output modules in their own DEB packages.

> - Update the apt cache:

          sudo apt-get update

> - List the available packages:  

          sudo apt-cache search ncid

> - Install the server and client:  

          sudo apt-get install ncid ncid-client

> - Install any optional output modules wanted:  

          sudo apt-get install ncid-<module>

> If the latest packages are not available at the repository:

> - Download the latest NCID deb packages from sourceforge  

          ncid DEB Package  
          ncid-client DEB Package - client and default output modules

> For example, to download ncid and ncid-client version 1.0

        wget http://sourceforge.net/projects/ncid/files/ncid/1.0/ncid_1.0-1_armhf.deb  
        wget http://sourceforge.net/projects/ncid/files/ncid/1.0/ncid_1.0-1_all.deb

> - Download any optional output modules wanted:  

          ncid-MODULE DEB Package  - optional client output modules

> Use gdebi to install the local NCID packages and dependent packages.  

        Using "sudo dpkg -i < package >" will not install dependent packages.  
        Using "sudo apt-get install < package >" will not install local packages.

> - Install or Upgrade the packages using gdebi-gtk (GUI):
    + If needed use the the menu item "Add/Remove.." to install the
          GDebi Package Installer.
    + Using the file viewer:
      - Open the file viewer to view the NCID DEB packages
      - Select the DEB packages
      - double click selections or right click selections and select
        "Open with GDebi Package installer"

> - Install or Upgrade the packages using gdebi (command line):

>> - Install gdebi if needed:  

              sudo apt-get install gdebi    

>> - Install the NCID server and gateways:  

              sudo gdebi ncid-<version>_armhf.deb

>> - Install the client package and default modules:  

              sudo gdebi ncid-client-<version>_all.deb

>> - Install any optional modules wanted:  

              sudo gdebi ncid-<module-<version>_all.deb

> #### Notes:  

        < version > would be something like: 1.0-1  
        < module > would be a module name like: kpopup, mythtc, samba

### <a name="instl_rasp_conf"></a>CONFIGURE:

> The ncidd.conf file is used to configure ncidd.

> - The default modem port in ncidd is /dev/modem.  This is just a
    symbolic link to the real modem port. It is probably best to
    set your modem port in ncidd.conf.  This assumes serial port 1:  

          set ttyport = /dev/ttyACM0

> - If you are using a SIP or YAC gateway instead of a local modem,
    you need to set noserial to 1:  

          set noserial = 1

> - If you are using a local modem with or without a SIP or YAC gateway:  

          set noserial = 0  (this is the default)

### <a name="instl_rasp_fs"></a>FIRST STARTUP:

> - if you are running the server and client on the same computer
      and using a modem:

          sudo invoke-rc.d ncidd start
          ncid &

> - If you are running the server and using a SIP gateway:

          sudo invoke-rc.d ncidd start
          sudo invoke-rc.d sip2ncid start
          ncid &

> - If you are running the server and using a Whozz Calling gateway:
      You need to install the Data::HexDump Perl module using cpan:

          cpan
            interactive mode, first use will enter configure
            configure as much as possible automatically
            choose sudo from: (Choose 'local::lib', 'sudo' or 'manual')
            automatically choose some CPAN mirror
            when configure finished, it displays the cpan prompt: cpan[1]>
          install Data::HexDump
          quit (quits cpan)
          sudo invoke-rc.d ncidd start
          sudo invoke-rc.d wc2ncid start
          ncid &

> - If you are running the server and using a YAC gateway:

          sudo invoke-rc.d ncidd start  
          sudo invoke-rc.d yac2ncid start  
          ncid &

> - Call yourself and see if it works, if not,

>> + stop the gateway used:  

              sudo invoke-rc.d sip2ncid stop

>> + stop the server:  

              sudo invoke-rc.d ncidd stop

>> + and continue reading the test sections.

> - If everything is OK, enable the NCID server, gateways, and
    client modules, your are using, to autostart at boot.  The
    GUI ncid client must be started after login, not boot

> #### NOTE:
>> ncid normally starts in the GUI mode and there is no
   ncid.init script to start or stop it.  There are rc.init
   scripts for starting ncid with output modules, for
   example: ncid-page, ncid-kpopup, etc.

### <a name="instl_rasp_ss"></a>START/STOP/STATUS:

> Use the invoke-rc.d command to start any of the daemons.  The invoke-rc.d
  commands are: start, stop, restart, reload, and status.  The client
  can also be started using the output module name instead of ncid.
  All output modules can be run at the same time.

> Here are some examples:

> - start the NCID server:

          sudo invoke-rc.d ncidd start

> - stop the ncid2sip server:

          sudo invoke-rc.d sip2ncid stop

> - reload the server alias file:

          sudo invoke-rc.d ncidd reload

> - start ncid with ncid-page:

          sudo invoke-rc.d ncid-page start

> - status of ncid with ncid-speak:

          sudo invoke-rc.d ncid-speak status

> Review the man page:

        man invoke-rc.d

### <a name="instl_rasp_as"></a>AUTOSTART:

> Use the update-rc.d command to enable/disable the service at boot.

> Here are some examples:

> - start ncidd at boot:

          sudo update-rc.d ncidd defaults

> - start ncid-page at boot:

          sudo update-rc.d ncid-page defaults

> Review the man page:

        man update-rc.d

## <a name="instl_red_top"></a>Redhat/Centos/Enterprise RPM Package Install

> If NCID does not work, see [INSTALL](#instl_generic_top) for some simple tests.  

> If using sip2ncid, see [sip2ncid setup](#gateways_sip).

> If using wc2ncid, see [wc2ncid setup](#gateways_wc).

> If using yac2ncid, see [yac2ncid setup](#gateways_yac).

> [Table of Contents](#doc_top)

### Sections:

> [COMPILE:](#instl_red_comp)    
  [INSTALL or UPGRADE:](#instl_red_iu)    
  [CONFIGURE:](#instl_red_conf)    
  [FIRST STARTUP:](#instl_red_fs)    
  [START/STOP/RESTART/RELOAD/STATUS:](#instl_red_ss)    
  [AUTOSTART:](#instl_red_as)  

### <a name="instl_red_comp"></a>COMPILE:

> The following packages are required:

> - sudo yum install libpcap-devel

> See [INSTALL (generic)](#instl_generic_top) for compile instructions

### <a name="instl_red_iu"></a>INSTALL or UPGRADE:

> NCID requires the server and client RPM packages to function.  The
  server is required on one computer or device, but the client can be
  installed on as many computers as needed.

> The client has a few output modules in its RPM package, and there
  are optional output modules in their own RPM packages.

> - Download server and client RPM Packages from Fedora repositories  

          ncid RPM Package         - server and gateways  
          ncid-client RPM Package  - client and default output modules

> - Download any optional output modules wanted:  

          ncid-MODULE RPM Package  - optional client output modules

> - Install or Upgrade the packages:

          Using the file viewer:
              * Open the file viewer to view the NCID RPM packages
              * Select the RPM packages
              * right click selections and select "Open with Package installer"

          Using YUM:
              * sudo yum install ncid\*.rpm

### <a name="instl_red_conf"></a>CONFIGURE:

> The ncidd.conf file is used to configure ncidd.

> - The default modem port in ncidd is /dev/modem.  This is just a
    symbolic link to the real modem port. It is probably best to
    set your modem port in ncidd.conf.  This assumes serial port 1:

          set ttyport = /dev/ttyS0

> - If you are using a SIP or YAC gateway instead of a local modem,
    you need to set noserial to 1:

          set noserial = 1

> - If you are using a local modem with or without a SIP or YAC gateway:

          set noserial = 0  (this is the default)

### <a name="instl_red_fs"></a>FIRST STARTUP:

> - if you are running the server and client on the same computer
    and using a modem:

          sudo service ncidd start  
          ncid &

> - If you are running the server and using a SIP gateway:

          service ncidd start  
          sudo service sip2ncid start  
          ncid &

> - If you are running the server and using a Whozz Calling gateway:

          sudo service wc2ncid start  
          sudo service wc2ncid start  
          ncid &

> - If you are running the server and using a YAC gateway:  

          sudo service ncidd start  
          sudo service yac2ncid start  
          ncid &

> - Call yourself and see if it works, if not,

          + stop the gateway used:  
            sudo service sip2ncid stop

          + stop the server:  
            sudo service ncidd stop

          + and continue reading the test sections.

> - If everything is OK, enable the NCID server, gateways, and
      client modules, your are using, to autostart at boot.  The
      GUI ncid client must be started after login, not boot.

> #### NOTE:
>> The ncid client normally starts in the GUI mode and there is no
   ncid.init script to start or stop it.

>> There are rc.init scripts for starting ncid with output modules,
   for example:

>> ncid-page, ncid-kpopup, etc.

### <a name="instl_red_ss"></a>START/STOP/RESTART/RELOAD/STATUS:

> Use the service command to start any of the daemons.  The service
  commands are: start, stop, restart, reload, and status.  The client
  can also be started using the output module name instead of ncid.
  All output modules can be run at the same time.

> Here are some examples:

> - start the NCID server:

          sudo service ncidd start

> - stop the ncid2sip server:

          sudo service sip2ncid stop

> - reload the server alias file:

          sudo service ncidd reload

> - start ncid with ncid-page:

          sudo service ncid-page start

> - get the status of ncid with ncid-speak:

          sudo service ncid-speak status

> Review the man page (man service).

### <a name="instl_red_as"></a>AUTOSTART:

> Use the chkconfig command to turn the service on/off for starting at boot.

> Here are some examples:

> - autostart ncidd at boot:

          sudo chkconfig ncidd on

> - autostart ncid-page at boot:

          sudo chkconfig ncid-page on

> - autostart ncid-kpopup at boot:

          sudo chkconfig ncid-kpopup on

> - list runlevels for sip2ncid:

          sudo chkconfig --list sip2ncid

> - remove ncid-speak from starting at boot:

          sudo chkconfig ncid-speak off

> Review the manpage (man chkconfig).

## <a name="instl_tivo_top"></a>TiVo TAR Package Install

> The ncid client replaces the old tivocid package.  It
  functions exactly like TiVoCID, if it is called tivocid,
  or if it is given the proper options.  The ncid client
  requires the out2osd package to be installed to display
  the CID information on the TV screen.

> The ncid client is also called tivoncid and uses the new
  ncid-tivo output module that uses /tvbin/text2osd to
  display the CID information.

> The NCID package includes both the client and server.
  For a series1, the server would normally be ignored unless
  you have a DirecTiVo, a hardware modified internal modem,
  or a modem connected to the serial port.

> [Table of Contents](#doc_top)

### Sections:

> * [COMPILE NCID](#instl_tivo_comp)  
> * [Install TiVoCID, TiVoNCID, sip2ncid, and ncidd](#instl_tivo_inst)  
> * [Optional: Install the TiVo OUT2OSD display program](#instl_tivo_out)  
> * [Optional: Install Perl](#instl_tivo_ip)  
> * [Configure ncidd, if you are running it on the TiVo](#instl_tivo_cs)  
> * [Start and verify the ncid package is working](#instl_tivo_sv)  
> * [Completing ncidd setup](#instl_tivo_cn)  
> * [Test using a Modem](#instl_tivo_mt)  
> * [TEST USING sip2ncid:](#instl_tivo_st)  
> * [TEST USING yac2ncid:](#instl_tivo_yt)  
> * [Install ncidd on a separate computer, if not using it on the TiVo](#instl_tivo_is)  
> * [Test the TiVo CID Client (if using tivocid)](#instl_tivo_cc)  
> * [Test the TiVo NCID Client (if using tivoncid)](#instl_tivo_nc)  
> * [Files installed and modem information](#instl_tivo_fi)  
> * [Notes](#instl_tivo_note)  

### <a name="instl_tivo_comp"></a>COMPILE NCID

> See the [Compile](#instl_generic_compile) section of [INSTALL (generic)](#instl_generic_top).

### <a name="instl_tivo_inst"></a>Install TiVoCID, TiVoNCID, sip2ncid, and ncidd

> You have a choice of using either tivocid or tivoncid as your display
  client.  Tivocid uses out2osd which does not work on all TiVo software
  hardware combinations.  Tivoncid should work on all TiVo software and
  hardware combinations.

> It is recomended you use tivoncid.

> If this is an upgrade, you need to save the configuration filesfirst:
>>  cp -a /var/hack/etc/ncid /var/hack/etc/ncid.old

> If you have a series 1 TiVo, Copy ncid-VERSION-tivo-ppc.tgz to the tivo.  
> If you have a series 2 TiVo, Copy ncid-VERSION-tivo-mips.tgz to the tivo.

> - tar -xzvf ncid-VERSION-tivo-mips.tgz -C /var

          EXAMPLE:
          tar -xzvf ncid-0.5-tivo-mips.tgz -C /var

> If this is an upgtade, modify any of the configuration files previously
  modified and saved in /var/hack/etc/ncid.old.  The new configuration
  files may have new comments and lines that can be modified so do not
  replace a new configuration with the old one.  Normally you would have
  modified just ncidd.conf and ncidd.alias.

### <a name="instl_tivo_out"></a>Optional: Install the TiVo OUT2OSD display program 

> The tivocid script uses out2osd for display.  The out2osd
  program only works on a Series 1 and a Series 2.  It is
  recomended you use the tivoncid script instead of tivocid.

> Get and install the latest OUT2OSD display program.
  It is available as either a source tar file, or a
  TiVo binary tar package.

### <a name="instl_tivo_ip"></a>Optional: Install Perl

> If you would like to use the cidcall, cidalias, and update
  scripts, you need to get and install Perl into /var/hack/bin

### <a name="instl_tivo_cs"></a>Configure ncidd, if you are running it on the TiVo

> Ncidd is compiled to use directories under /var/hack.
  You can change this if you like, by using the
  command line to specify the location of the config
  file, and then using the config file to set the
  options for your new directory structure.

> If you are using a modem:

>> The ncidd.conf file is preconfigured for a TiVo.
   These are the lines enabled for a Series1 and a Series2:

            set sttyclocal = 1  
            set modem = /dev/ttyS1 # TiVo Modem Port  
            set lockfile = /var/tmp/modemlock # needed for TiVo Modem Port

>>  If you are using a standalone series1 without the modem hardware
    modification to enable Caller ID, you need to uncomment the line:

            # set modem = /dev/ttyS3 # TiVo Serial Port

>> and comment out the line::

            set modem = /dev/ttyS1 # TiVo Modem Port

> If you are using using sip2ncid or yac2ncid instead of a modem:

>> You need to uncomment the line:

            # set noserial = 1

### <a name="instl_tivo_sv"></a>Start and verify the ncid package is working

> Use the startncid script to start NCID and use stopncid to
  stop all running NCID programs.

> After you configure and start startncid as indicated below,
  check that the programs are running:

>> pgrep -fl ncid

> If you are running the server and client on the TiVo
and are using tivoncid with a modem:

>> use the startncid script:  
>>> /var/hack/bin/startncid

>> startncid executes these commands:
>>> ncidd  
    tivoncid &

> If you are running the server and client on the TiVo
  and are using tivoncid with sip2ncid:

>> uncomment one of the timesone lines, for example:
>>> TZ=EST5EDT,M3.2.0,M11.1.0    # EASTERN TIME

>> uncomment this line in startncid:
>>> SIPGW=sip2ncid

>> use the startncid script:
>>> /var/hack/bin/startncid

>> startncid executes these commands:
>>> ncidd  
    sip2ncid
    tivoncid &

> If you are running the server and client on the TiVo
> and are using tivoncid with yac2ncid:

>> uncomment this line in startncid:
>>> YACGW=yac2ncid

>> use the startncid script:
>>> /var/hack/bin/startncid

>> startncid executes these commands:
>>> ncidd  
    yac2ncid  
    tivoncid &

> If you are only running the client on the TiVo:

>> modify ncid.conf:

            change this line: set Host        127.0.0.1  
            to this line:     set Host        < NCID server IP address >

>> example using the command line:
>>> tivoncid IP.Server.Address &

>> If the server is at 192.168.0.10, the above becomes:

>>> tivoncid 192.168.0.10 &

> If you are running the server and client on the TiVo
  and are using tivocid with a modem:

>> comment the OSDCLIENT line in startncid:
>>> \#OSDCLIENT=tivoncid

>> uncomment the OSDCLIENT line in startncid:
>>> OSDCLIENT=tivocid

>> use the startncid script:
>>> /var/hack/bin/startncid

>> startncid executes these commands:
>>> ncidd  
    tivocid &

> Call yourself and see if it works, if not, kill off ncidd, if
  it is running, and continue reading the test sections.

> Once you are satisfied that everything is working OK, complete the
  setup of NCID.


### <a name="instl_tivo_cn"></a>Completing ncidd setup

> NCID has a start up script, /var/hack/bin/startncid, to start the
  server, gateway, cliets you are using, and to set up the environment.
  It is preconfigured to start ncidd, and tivoncid.  You need to edit
  it if you want to set up your local timezone, or if you want to start
  tivoncid instead of tivocid, sip2ncid, ncid-yac, or ncid-initmodem.
  Do not configure both tivocid and tivoncid or both will try to display
  the Caller ID on screen.

> After you customise startncid, add /var/hack/bin/startncid to the
  /etc/rc.d/rc.sysinit.author file.

> If you have a problem with your modem dropping out of Caller ID,
  you can use the ncid-initmodem module to re-initialize the modem
  when a call is detected without Caller ID.  This module must only
  be used when you are using a modem to obtain the Caller ID.  The
  modem must provide ring detection for this to work.

> You can also use /var/hack/bin/initmodem manually or call it from
  cron to re-initialize the modem.  It can be used with ncid-initmodem.

### <a name="instl_tivo_mt"></a>Test using a Modem

> The easiest way to test the setup is to run ncidd in debug mode,
  it will stay attached to the terminal and not go into daemon mode:
>> ncidd -D

> to get more information, add the verbose flag:
>> ncidd -Dv3

> to also look at the alias structure
>> ncidd -Dv5

> The last three lines will be similar to:

          Modem set for CallerID.  
          Port: 3333  
          pid 20996 in pidfile: /var/run/ncidd.pid  

> Call yourself and you should see the CallerID information.  

> - If you just see RING and no Caller ID lines,
    the modem does not support caller ID.

> - If you see: /dev/ttyS1: No such file or directory
    you need to set sttyclocal in ncidd.conf
                                                                  
> - At any point, you can use command lines options to vary
    things like modem init and CID init.

> Once it works, you would normally start it:

          ncidd    

> or, if, for example, you use /hack instead of /var/hack:  

          ncidd -C /hack/etc/ncidd.conf

### <a name="instl_tivo_st"></a>TEST USING sip2ncid:

> - Start (in this order):

          ncidd  
          sip2ncid (may need to add options, review [sip2ncid setup](#gateways_sip))  
          or tivoncid

> - Call yourself

>> if you have problems, start ncidd in debug mode:

          ncidd -D

>> to get more information, add the verbose flag:

          ncidd -Dv3

>> to also look at the alias structure

          ncidd -Dv5

> - The last three lines will be similar to:

          CallerID only from CID gateways  
          Network Port: 3333  
          Wrote pid 20996 in pidfile: /var/run/ncidd.pid

> - Once you solve any problems, restart ncidd normally

### <a name="instl_tivo_yt"></a>TEST USING yac2ncid:

> - Start (in this order):

>> ncidd  
   yac2ncid (may need to add options)  
   tivocid or tivoncid

> - Call yourself

>> if you have problems, start ncidd in debug mode:

            ncidd -D

>> to get more information, add the verbose flag:

            ncidd -Dv3

>> to also look at the alias structure

            ncidd -Dv5

>> The last three lines will be similar to:

            CallerID only from CID gateways  
            Port: 3333  
            pid 20996 in pidfile: /var/run/ncidd.pid

> - Once you solve any problems, restart ncidd normally

### <a name="instl_tivo_is"></a>Install ncidd on a separate computer, if not using it on the TiVo

> Get, install, and test the latest NCID server/client package
  for the computer you will run it on, if it is not the TiVo.

> NCID is available as either a source tar file, or a Redhat RPM package,

### <a name="instl_tivo_cc"></a>Test the TiVo CID Client (if using tivocid)

> Start tivocid:

> - If ncidd is on the TiVo:

          tivocid -V  
          You should see the Server connect message.

> - If ncidd is on another computer:

          tivocid -V IP.Server.Address.  
          You should see the Server connect message.

> If it dosen't start, the error message should give you a clue.

> There is one report of tivocid aborting with a message similar to:

          bash-2.02# Tmk Assertion Failure:  
          FsAllocateFunction, line 131 ()

> If tivosh dies in the wrong place, the tivo will restart:

          Tmk Fatal Error: Thread tivosh <252> died due to signal -2
          f9c51c 100df1c 100e18c 100e1dc dabe9c dab55c 400c50 108a0b0 
          Restarting system.

> The fix is to start it this way:

          tivosh ncid --no-gui -T --call-prog --program /var/hack/bin/out2osd &

> Call yourself.  The display should show up for 10 seconds
  and then erase itself.

> If tivocid dosen't display the Caller ID information, try:

          tivocid -R -V IP.Server.Address.

> This will show everything received from the server, and
  the CID information it processes.

> If tivocid works, kill off tivocid and restart it:

>> If ncidd is on the TiVo:

          tivocid &

>> If ncidd is on another computer:

          tivocid IP.Server.Address &

### <a name="instl_tivo_nc"></a>Test the TiVo NCID Client (if using tivoncid)

> Start tivoncid:

>> If ncidd is on the TiVo:

          tivoncid -V  

>> You should see the Server connect message.

>> If ncidd is on another computer:

          tivoncid -V IP.Server.Address.

>> You should see the Server connect message.

> If it does not start, the error message should give you a clue.

> There is one report of tivocid aborting with a message similar to:

          bash-2.02# Tmk Assertion Failure:  
          FsAllocateFunction, line 131 ()

> If tivosh dies in the wrong place, the tivo will restart:

          Tmk Fatal Error: Thread tivosh <252> died due to signal -2
          100df1c 100e18c 100e1dc dabe9c dab55c 400c50 108a0b0 Restarting

> The fix for this is to start it this way:

          tivosh ncid --no-gui --call-prog --program ncid-tivo &

> Call yourself.  The display should show up for 10 seconds
  and then erase itself.

> If tivocid does not display the Caller ID information, try:

          tivoncid -R -V IP.Server.Address.

> This will show everything received from the server, and
  the CID information it processes.

> If tivoncid works, kill off tivoncid and restart it:

>> If ncidd is on the TiVo:

          tivoncid &

>> If ncidd is on another computer:

          tivoncid IP.Server.Address &

### <a name="instl_tivo_fi"></a>Files installed and modem information

> The series1 tivo requires a hardware modification to support
  Caller ID, but you can hang a modem off of the serial port using
  the TiVo serial cable and a modem serial cable connected together.

> Series1 information on the hardware modification needed, various
  CID init strings, and another Caller ID program can be found here:

>> [Caller-id program for DirecTivo](http://archive.tivocommunity.com/tivo-vb/showthread.php?s=&threadid=54469&highlight=Elseed)

> [TiVo Modems](#modems_tivo) gives some information about the TiVo modems.

> The tar file creates and populates the following directories

            hack
              |-- bin
              |-- sbin
              |-- etc -- ncid -- conf.d
              |-- log
              |-- doc -- ncid -- man
              |-- dev
              |-- share -- ncid


### <a name="instl_tivo_note"></a>Notes

            tivocid is a symbolic link to ncid  
            tivoncid is also a symbolic link to ncid

## <a name="instl_ubuntu_top"></a>Ubuntu DEB Package Install

> If NCID does not work, see [INSTALL](#instl_generic_top) for some simple tests.  

>  If using sip2ncid, see [sip2ncid setup](#gateways_sip).  

> If using wc2ncid, see [wc2ncid setup](#gateways_wc).

> If using yac2ncid, see [yac2ncid setup](#gateways_yac).

> [Table of Contents](#doc_top)

### Sections:

> [COMPILE:](#instl_ubuntu_comp)  
  [INSTALL or UPGRADE:](#instl_ubuntu_iu)  
  [CONFIGURE:](#instl_ubuntu_conf)  
  [FIRST STARTUP:](#instl_ubuntu_fs)  
  [START/STOP/RESTART/RELOAD/STATUS:](#instl_ubuntu_ss)  
  [AUTOSTART:](#instl_ubuntu_as)
  [Package Removal:](#instl_ubuntu_rm)

### <a name="instl_ubuntu_comp"></a>COMPILE:

> The following packages are required:

        - sudo apt-get install build-essential
        - sudo apt-get install libpcap0.8-dev
    
> See INSTALL for compile instructions

### <a name="instl_ubuntu_iu"></a>INSTALL or UPGRADE:

> NCID requires the server and client DEB packages to function.  The
    server is required on one computer or device, but the client can be
    installed on as many computers as needed.

> The client has a few output modules in its DEB package, and there
    are optional output modules in their own DEB packages.

> If installing from 3rd Party Repository: GetDeb Apps

> - Add the repository if needed:

          wget -q -O - http://archive.getdeb.net/getdeb-archive.key | sudo apt-key add -  
          sudo sh -c "echo 'deb http://archive.getdeb.net/ubuntu precise-getdeb apps' >> /etc/apt/sources.list"

> - Update the apt cache:

          sudo apt-get update

> - List the available packages:

          sudo apt-cache search ncid

> - Install the server and client:

          sudo apt-get install ncid ncid-client

> - Install any optional output modules wanted:

          sudo apt-get install ncid-<module>

> #### IMPORTANT:

> - the repository install usually makes all servers start
    at boot, this will cause problems when the systen is
    rebooted.  Disable any servers you are not using:

          sudo update-rc.d sip2ncid disable
          sudo update-rc.d wc2ncid disable
          sudo update-rc.d rn2ncid disable
          sudo update-rc.d yum2ncid disable

> If the latest packages are not available at the repository:

> - Download the latest NCID deb packages from sourceforge

          ncid DEB Package

          ncid-client DEB Package
         (client and default output modules)

> - Download any optional output modules wanted:

          ncid-MODULE DEB Package
          (optional client output module)

> Use gdebi to install the local NCID packages and dependent packages.
> 
> + Using "sudo dpkg -i <package>"  
    will not install dependent packages.  
> + Using "sudo apt-get install <package>"  
    will not install local packages.

> - Install or Upgrade the packages using gdebi (command line):

         - Install gdebi if needed:  
           sudo apt-get install gdebi
         - Install the NCID server and gateways:  
           sudo gdebi ncid-<version>_armhf.deb  
         - Install the client package and default modules:  
           sudo gdebi ncid-client-<version>_all.deb
         - Install any optional modules:  
           sudo gdebi ncid-<module-<version>_all.deb  
>      Notes:  
        <version> would be something like: 1.0-1  
        <module> would be a module name like: kpopup, mythtc, samba
<br><br>

> - Install or Upgrade the packages using gdebi-gtk (GUI):

           If needed use the the menu item "Add/Remove.."
           to install the GDebi Package Installer.

           Using the file viewer:  
           - Open the file viewer to view the NCID DEB packages  
           - Select the DEB packages  
           - double click selections or right click selections and select
             "Open with GDebi Package installer"

### <a name="instl_ubuntu_conf"></a>CONFIGURE:

> The ncidd.conf file is used to configure ncidd.

> - The default modem port in ncidd is /dev/modem.  This is just a
    symbolic link to the real modem port. It is probably best to
    set your modem port in ncidd.conf.  This assumes serial port 1:

           set ttyport = /dev/ttyS0

> - If you are using a SIP or YAC gateway instead of a local modem,
    you need to set noserial to 1:

           set noserial = 1

> - If you are using a local modem with or without a SIP or YAC gateway:

           set noserial = 0  (this is the default)

### <a name="instl_ubuntu_fs"></a>FIRST STARTUP:

> - if you are running the server and client on the same computer
      and using a modem:

          sudo invoke-rc.d ncidd start
          ncid &

> - If you are running the server and using a SIP gateway:

          sudo invoke-rc.d ncidd start
          sudo invoke-rc.d sip2ncid start
          ncid &

> - If you are running the server and using a Whozz Calling gateway:
      You need to install the Data::HexDump Perl module using cpan
      and then start the server, gateway, and client:

          cpan
            (interactive mode, first use will enter configure
            configure as much as possible automatically
            choose sudo from: Choose 'local::lib', 'sudo' or 'manual'
            automatically choose some CPAN mirror
            at cpan prumpt install module)

            install Data::HexDump
            quit

          sudo invoke-rc.d ncidd start
          sudo invoke-rc.d wc2ncid start
          ncid &

> - If you are running the server and using a YAC gateway:

          sudo invoke-rc.d ncidd start  
          sudo invoke-rc.d yac2ncid start  
          ncid &

> - Call yourself and see if it works, if not:

          - stop the gateway used:
            sudo invoke-rc.d sip2ncid stop
          - stop the server:
            sudo invoke-rc.d ncidd stop
          - continue reading the test sections.

> - If everything is OK, enable the NCID server, gateways, and
    client modules, your are using, to autostart at boot.  The
    GUI ncid client must be started after login, not boot

>> NOTE:

>> ncid normally starts in the GUI mode and there is no
    ncid.init script to start or stop it.

>> There are rc.init scripts for starting ncid with output modules, for
    example:

          ncid-page, ncid-kpopup, etc.

### <a name="instl_ubuntu_ss"></a>START/STOP/RESTART/RELOAD/STATUS:
START/STOP/STATUS:

> Use the invoke-rc.d command to start any of the daemons.  The invoke-rc.d
  actions are: start, stop, restart, reload, and status.  The client
  can also be started using the output module name instead of ncid.
  All output modules can be run at the same time.

> Here are some examples:

        - start the NCID server:
          sudo invoke-rc.d ncidd start  
        - stop the ncid2sip server:
          sudo invoke-rc.d sip2ncid stop  
        - reload the server alias file:
          sudo invoke-rc.d ncidd reload  
        - start ncid with ncid-page:
          sudo invoke-rc.d ncid-page start  
        - status of ncid with ncid-speak:
          sudo invoke-rc.d ncid-speak status

> Review the man page.  
  (man invoke-rc.d).

### <a name="instl_ubuntu_as"></a>AUTOSTART:

> Use the update-rc.d command to enable/disable the service at boot.

> Here are some examples:

       - start ncidd at boot:
         sudo update-rc.d ncidd defaults  
       - start ncid-page at boot:
         sudo update-rc.d ncid-page defaults

> Review the man page.  
  (man update-rc.d)

### <a name="instl_ubuntu_rm"></a>Package Removal:

> Use apt-get to remove the lcdncidi package:

       - normal removal without removing configuration files and dependencies:
         apt-get remove lcdncid
       - complete removal including dependencies:
         sudo apt-get --purge autoremove lcdncid

> Review the man page.  
  (man apt-get)

## <a name="instl_win_top"></a>Windows Install

> Install either the Windows client package or the complete package.

> [Table of Contents](#doc_top)

### Sections:

> [WINDOWS CLIENT INSTALL:](#instl_win_inst)  
  [WINDOWS COMPLETE COMPILE:](#instl_win_cc)  
  [WINDOWS COMPLETE INSTALL:](#instl_win_ci)  
  [NCID.TCL INSTALL:](#instl_win_tcl)  

### <a name="instl_win_inst"></a>WINDOWS CLIENT INSTALL:

> Install this package if you only need the client.

> - Execute the ncid installer:

          ncid-?.?-setup.exe  

>>  where ?.? is the version number, for example:

          ncid-1.0-setup.exe

> - Configure ncid in the configure screen.  The default address is
    127.0.0.1, so you will need to change it to the address of your
    ncid server, for example:

          "ncid.sourceforge.net" or "192.168.22.10"

> - The installer will not auto start ncid at login, you can create
    a link in the start menu if you like.  See below for configuring
    the link.

### <a name="instl_win_cc"></a>WINDOWS COMPLETE COMPILE:

> See [INSTALL (generic)](#instl_generic_top) and  
  [INSTALL-Cygwin](#instl_cygwin_top) or  
  [INSTALL-Ubuntu](#instl_ubuntu_top).

### <a name="instl_win_ci"></a>WINDOWS COMPLETE INSTALL:

> [INSTALL-Ubuntu](#instl_ubuntu_top) on Windows or  
  [INSTALL-Cygwin](#instl_cygwin_top)

> if you need to install the
  complete NCID package, including server, client, and gateways.

> The serial port functions of ncidd do not work under Windows or
  Cygwin so you must use the SIP or YAC gateway with it.  It is
  unknown if a modem will work under Ubuntu so you may need to
  use a gateway with it also.  If a modem is usable, it should
  be a modem that supports Linux like the USB modems described
  in [Incomplete list of working modems](#modems_list).

> NCID under Cygwin is a fairly complex command line install, and there
  are some performance issues with it.  It is recommended you try Ubuntu.  

> See [INSTALL-Cygwin](#instl_cygwin_top) if you want to install Cygwin 
  and NCID.

> NCID under Ubuntu is an easy install.  You can use the GUI based
  package manager to install/update/remove it.  

> See [INSTALL-Ubuntu](#instl_ubuntu_top) if you want to install 
  Ubuntu and NCID.

### <a name="instl_win_tcl"></a>NCID.TCL INSTALL:

> Use this method only if you want to run ncid.tcl instead of ncid.exe
  This was the original install method.  You need to get ncid.tcl from
  the source package.

> Download the tcl/tk interpreter:

> - http://aspn.activestate.com/ASPN/Downloads/ActiveTcl/
> - click on download
> - click on next
> - click on ActiveTcl ?.?.?.? Self-extracting AS Package

> Install tcl/tk:

> - Run the file downloaded: ActiveTcl?.?.?.?-win32-ix86.exe

> Install ncid:

> - Unzip ncid-0.?.zip to c:\ or any location you prefer
    it will add a directory called ncid with files in it.

> - Create a shortcut on the desktop to ncid.tcl, for example:  

          c:\ncid\ncid.tcl

> - If the server is not on the same computer, open the
    shortcut properties and include the IP address (or the
    DNS name) with the program name in "Target:" field.

>> for example, if Target has C:\ncid

>> add IP address:

            C:\ncid 192.168.0.1

>> or, if path, in Target has spaces:

            E:\Program Files\ncid

>> add quotes around path, then add the IP address or DNS name:  

            "E:\Program Files\ncid" 192.168.0.1

## <a name="verbose_top"></a>Verbose Levels

> [Table of Contents](#doc_top)

### Index

> * [ncid verbose levels](#verbose_ncid)
  * [ncid2ncid verbose levels](#verbose_ncid2ncid)
  * [ncidd verbose levels](#verbose_ncidd)
  * [rn2ncid verbose levels](#verbose_rn2ncid)
  * [sip2ncid verbose levels](#verbose_sip2ncid)
  * [wc2ncid verbose levels](#verbose_wc2ncid)

### <a name="verbose_ncid"></a>ncid verbose levels
>  Higher levels include lower levels.

> LEVEL9:

        not used

> LEVEL8:

        not used

> LEVEL7:

        not used

> LEVEL6:

        not used

> LEVEL5:

        display the line type as a numeric
        show CIDINFO line

> LEVEL4:

        shows fixed font family
        display history entries in  milliseconds

> LEVEL3:

        not used

> LEVEL2:

        not used

> LEVEL1:

        indicate if using PID file or not
        display about
        indicate if a output module is being used and which one
        indicate if optional module variable is not being used
        indicate if optional module variable is being used and ring count
        display received data if in raw mode
        indicate when call log is completely received
        show CIDINFO line on ring count match
        show data sent to module
        indicate if phone line label not found
        show message sent to module
        show CID data sent to module
        show unsupported line labels
        show unsupported alias types
        display popup message

### <a name="verbose_ncid2ncid"></a>ncid2ncid gateway verbose levels
>  Higher levels include lower levels.

> LEVEL9:

        (can only be set by the command line)

        Indicate reading socket

> LEVEL8:

        (can only be set by the command line)

        Show all data received from all servers

> LEVEL7:

        not used

> LEVEL6:

        not used

> LEVEL5:

        not used

> LEVEL4:

        not used

> LEVEL3:

        not used

> LEVEL2:

        not used

> LEVEL1:

        indicate cannot create or open existing logfile
        show start date and time
        show server version
        indicate Debug mode
        indicate no config file
        indicate config file processed
        indicate set command skipped in config file
        show error line in config file
        show verbose level
        indicate not using PID file, there was no '-P' option
        indicate found stale pidfile
        indicate wrote pid in pidfile
        show Receiving Host host:port
        show server greeting line
        show configured Sending Hosts host:port
        show configured servers greeting line
        indicate client disconnected
        indicate client reconnected
        indicate Hung Up
        indicate Poll Error
        indicate Removed client, invalid request
        indicate Removed client, write event not configured
        indicate line cannot be sent to receiving NCID server
        indicate line sent to receiving NCID server
        indicate removed pidfile
        show terminated with date and time

### <a name="verbose_ncidd"></a>ncidd server verbose levels
>  Higher levels include lower levels.

> LEVEL9:

        (can only be set by the command line)

        show poll() events flag

> LEVEL8:

        (can only be set by the command line)

        show alias table
        show blacklist  and whitelist tables
        indicate client sent empty line

> LEVEL7:

        not used

> LEVEL6:

        not used

> LEVEL5:

        display data as a hexdump
        show modem command return codes for hangup

> LEVEL4:

        show optional files failed to open
        show lastring and ring count if ring detected

> LEVEL3:

        show number of tries to init modem
        show modem responses
        show modem query commands for software version, country code, operation modes
        show client connect/disconnect
        indicate Non 7-bit ASCII message deleted
        indicate Gateway sent CALL data
        indicate Gateway sent CALLINFO data
        indicate Client sent text message
        indicate client sent unknown data
        show call data input
        show CIDINFO line
        show CID line
        show IDENT received, not received, or ignored
        show ACK line

> LEVEL2:

        show lines that start with a 3 digit numbe
        indicate network client hung up
        indicate device or modem returned no data
        show line sent to cidupdate
        show line sent to ncidutil
        show OPT lines
        show REQ: lines
        show INFO: lines
        show WRK: lines
        show RESP: lines

> LEVEL1:

        show started with date and time
        show server version
        indicate if could not create ncidd logfile
        indicate name and location of ncidd logfile
        indicate if no config file
        indicate config file processed
        indicate set command skipped in config file
        show error line in config file
        indicate error in opening ncidd log file
        indicate what is configured to send to the clients
        show verbose level
        indicate data type sent to clients
        indicate alias file messages
        indicate if leading 1 needed for aliases
        indicate blacklist  and whitelist file messages
        indicate alias, blacklist, and whitelist total/maximum entries, if any
        indicate cid logfile messages
        indicate if no data logfile
        indicate name and location of data logfile
        show Telephone Line Identifier
        show TTY port opened
        show TTY port speed
        show name and location of TTY lockfile
        indicate TTY port control signals enabled or disabled
        indicate CallerID from serial device and optional gateways
        indicate CallerID from AT Modem and optional gateways
        indicate Handles modem calls without Caller ID
        indicate Does not handle modem calls without Caller ID
        indicate CallerID from Gateway
        indicate hangup option
        show network port
        indicate not using PID file if no '-P' option
        indicate pid file already exists
        indicate found stale pidfile
        indicate cannot write pidfile
        indicate wrote pid in pidfile
        indicate TTY in use with date and time
        indicate TTY free with date and time
        indicate cannot init TTY and terminated with date and time
        indicate Modem initialized.
        indicate Initialization string for modem is null.
        indicate Modem set for CallerID.
        indicate Modem does or does not support FAX
        indicate CallerID initialization string for modem is null.
        indicate CallerID TTY port initialized
        indicate serial device hung up and terminated with date and time
        indicate device error and terminated with date and time
        indicate serial device error and terminated with date and time
        indicate poll error
        indicate invalid request from serial device,terminated  with date and time
        indicate Invalid Request, removed client
        indicate Write event not configured, removed client
        indicate device or modem read error
        indicate Device returns no data, Terminated with date and time
        indicate network connect error
        indicate network NOBLOCK error
        indicate too many network clients
        indicate network client read error
        indicate cid log is too large
        indicate sending log to client
        indicate removed pidfile
        indicate signal received and terminate program with date and time
        indicate SIGHUP received and reload alias files
        indicate SIGPIPE received and ignored with date and time
        indicate Failed to remove stale lockfile
        indicate Removed stale lockfile

### <a name="verbose_rn2ncid"></a>rn2ncid gateway verbose levels
>  Higher levels include lower levels.

> LEVEL9:

        not used

> LEVEL8:

        not used

> LEVEL7:

        not used

> LEVEL6:

        not used

> LEVEL5:

        Show call log from ncidd, if received
        Show Caller ID line from ncidd

> LEVEL4:

        not used

        LEVEL3:

        Show notification type
        Show Call line if type RING
        Show PING or Battery message as notice
        Show notice of a SMS or MMS message
        Show unknown notification type
        Show id notification was rejected

> LEVEL2:

        not used

> LEVEL1:

        Show Started
        Show command line and any options on separate lines
        Show logfile name and opened as append or overwrite or could not open
        Show processed config file or config file not found
        Show name and version
        Show verbose level
        Show debug mode if in debug mode
        Show test mode if in test mode
        Show reject option values or none
        Show pid or some PID problem
        Show connected to NCID address:port or error exit
        Show greeting line from NCID
        Show listening port or error exit
        Show NCID server disconnected if it goes away and trying to reconnect

### <a name="verbose_sip2ncid"></a>sip2ncid gateway verbose levels
>  Higher levels include lower levels.

> LEVEL9:

        (can only be set by the command line)

        show lines received from the NCID server

> LEVEL8:

        not used

> LEVEL7:

        not used

> LEVEL6:

        not used

> LEVEL5:

        show linenum array and number as they are compared for a call
        indicate checked for "Call ID: call-" and outcall value

> LEVEL4:

        UDP packet from address
        UDP packet to address
        IP protocol
        UDP source port
        UDP destination port
        UDP data size in bytes
        indicate Alarm Timeout and msgsent flag

> LEVEL3:

        show UDP SIP packets
        give character count of lines received from the NCID server
        show alarm timeout, pcap\_loop() return value, and msgsent flags

> LEVEL2:

        indicate cannot write pidfile
        show packet number received
        show Duplicate INVITE Packet <pkt#> with <invpkt#>
        show Ignoring Trying Packet <pkt#>
        show Ignoring Ringing Packet <pkt#>
        show Warning: could not connect to the NCID server

> LEVEL1:

        indicate cannot create or open existing logfile
        show start date and time
        show server version
        indicate test mode
        indicate Debug mode
        indicate no config file
        indicate config file processed
        indicate set command skipped in config file
        show error line in config file
        indicate Reading from dumpfile
        indicate Writing to dumpfile
        show verbose level
        show status: Warn clients: 'No SIP packets' & 'SIP packets returned'
        show status:  Remove duplicate INVITE Packets?
        show NCID server host:port
        show network interface used
        show applied filter
        indicate no filter applied
        indicate No SIP packets received
        indicate SIP packets returned
        indicate not using PID file, there was no '-P' option
        indicate pid file already exists
        indicate found stale pidfile
        indicate wrote pid in pidfile
        alarm SIP packets returned
        Warning: SIP Packet truncated
        Warning: simultaneous calls exceeded
        invalid IP header length
        show registered line number
        indicate Number of telephone lines exceed
        show CID line sent to NCID
        indicate packet parse problems
        indicate caller hangup before answer
        indicate hangup after answer
        Warning: cannot get CallID
        Warning: Warning no SIP packets
        indicate pcap\_loop error
        indicate removed pidfile
        indicate program terminated with date and time

### <a name="verbose_wc2ncid"></a>wc2ncid gateway verbose levels
>  Higher levels include lower levels.

> LEVEL9:

        not used

> LEVEL8:

        not used

> LEVEL7:

        not used

> LEVEL6:

        not used

> LEVEL5:

        Show call log from ncidd, if received
        Show Caller ID line from ncidd

> LEVEL4:

        Show hex dump of received packet

> LEVEL3:

        Show unit and serial numbers from Whozz Calling device
        Show Call line from Whozz Calling device

> LEVEL2:

        Show CALL and CALLINFO lines sent to ncidd
        Show Phone Off Hook
        Show Phone On Hook

> LEVEL1:

        Show Started
        Show command line and any options on separate lines
        Show version
        Show verbose level
        Show debug mode if in debug mode
        Show test mode if in test mode
        Show logfile name and whether opened as append or overwrite
        Show logfile could not be opened
        Show processed config file or config file not found
        Show connected to NCID address:port or error exit
        Show greeting line from NCID
        Show opened broadcast port
        Show closed broadcast port
        Show opened WC device port
        Show closed WC device port
        Show commands sent
        Show Pause after sending ^^Id-V
        Show checking and setting required flags
        Indicate command data received or timeout in seconds
        Show data from some commands

## <a name="contrib_top"></a>NCID Contributors

> [Table of Contents](#doc_top)
 
> Any omissions are entirely my fault.  Please notify
  [jlc](mailto:jlc@users.sourceforge.net) for any corrections
  or additions.

#### [John L. Chmielewski](mailto:jlc@users.sourceforge.net)
*   Designed, developed, and wrote most of the programs.

#### [Mark Salyzyn](mailto:mark@bohica.net)
*   Ported `ncidd` to BSD and Macintosh.
*   Wrote `getopt.c` and `poll.c`.

#### Mace Moneta
*   Wrote `nciduser`, which was the basis for `ncid-speak`.
*   Contributed ideas and code to `ncid` client.
*   Contributed the Mac OS X portion of `ncid-speak`.

#### [Dan Lawrence](mailto:dan@cutthatout.com)
*   Contributed to `ncid-email` so paging would work.
*   Contributed information on [freewrap](http://freewrap.sourceforge.net/)
    for `ncid` client on Windows.
        

#### [Aron Green](mailto:agreen@pobox.com)
*   Helped fix `termios` settings to work with FreeBSD.
*   Contributed `ncid.sh` and `ncidd.sh` start/stop scripts for FreeBSD.
*   Contributed ideas for `ncidd` and `ncid`.

#### [Troy Carpenter](mailto:troy@carpenter.cx)
*   Developed `ncid-samba` to send CID info to Samba for a Windows popup.

#### [Lyman Epp](mailto:lyman@epptech.com)
*   Wrote the first version of `ncidrotate` in python.

#### Rick Matthews
*   Provided information on distinctive ring.

#### Michael Nygren
*   Provided information on the +GCI modem code, so CID will work with  
    modems that need a country code.

#### Mitch Riley
*   Provided information needed to create the `ncid-mythtv` script.

#### Roger Knobber
*   Provided patch for *strdate()* in `ncidd.c` to fix null pointer in  
    *gettimeofday()* in version 0.61.

#### [Rich West](mailto:Rich.West@wesmo.com)
*   Helps maintain the `ncid-mythtv` module.
*   Provided an NSIS script as a basic installer for the `ncid`  
    Windows client.

#### [Clayton O'Neill](mailto:coneill@oneill.net)
*   Modified `ncidd` to be able to run with no serial device.
*   Added the ability to inject CID from clients.
*   Contributed the `ncid-sipinject` program which was renamed  
    `ncidsip`.

#### [David LaPorte](mailto:dlaPorte@users.sourceforge.net)
*   Improved `ncidsip` to work with a missing name.
*   Improved `ncidsip` to detect outgoing calls containing a SIP REGISTER  
    packet so they are not treated as incoming calls.

#### [Michael Lasevich](mailto:michael@lasevich.net)
*   Wrote and contributed `yac2ncid`.
*   `ncid-yac` was developed from a module he wrote.
*   Helped write the man pages.

#### [Randy Rasmussen](mailto:randyr505@gmail.com)
*   Wrote and contributed the `ncid-kpopup` client output module.

#### Jonathan Wolf
*   Hacked `ncid` to provide ring indication when Caller ID not available.  
    (His hack was not used, but his feature was added to `ncidd`.)

#### [littlepepper](mailto:littlepepper@users.sourceforge.net)
*   Provided the Mac OS X modem init string for the iMac.

#### [Marko Koski-Vähälä](mailto:marko@koski-vahala.com)
*   Contributed `ncid` client code to format numbers for Sweden.  
    The client can now format numbers for "US" and "SE".

#### [Chris Lenderman](mailto:chris@lenderman.com)
*   Helped rewrite *sendLog()* code to eliminate corruption sending  
    large log files (greater than 2,000 lines).
*   Converted `testclient` from using *netcat* to using sockets.
*   Maintained the Windows version of `NCIDPop`.
*   Created (and maintains) a complete rewrite of `NCIDPop` in Java  
    making `NCIDPop` cross-platform for Mac, Windows, Linux.
*	Created (and maintains) `NCID Android` client. 

#### [Todd Andrews](mailto:taa@pobox.com)
*   Corrected problems in t
*   he INSTALL document.
*   Helped with server testing and fixing various Mac OS X problems.
*   Provided a server fix for the hangup configuration/option  
    problem on Mac OS X.
*   Developed `ncid-nma` output module which became part of `ncid-notify`.
*   Developed `wc2ncid` gateway.
*   Helped improve various NCID documentation.
*   Did a lot of work for the NCID 0.85 and 0.86 distributions.
*   In general, helps with various NCID programs and documentation.

#### [Charlie Heitzig](mailto:mail@heitzig.org)
*   Spent time debugging `sip2ncid` and `WinPcap`.
*   Contributed fix for `sip2ncid` so it exits instead of failing  
    while running when it receives a system error.
*   Developed `ncid-prowl` output module which became part of `ncid-notify`.

#### [Jeff Rabin](mailto:jeff@jrgator.com)
*   Helped with the `ncidd` hangup option by testing, reviewing  
    documentation, suggesting improvements, and providing patches.
*   Created the `ncidd` configuration option *ignore1* patches.

#### [Neven Ãosiã](mailto:senseitcom@email.t-com.hr)
*   Added country code HR (Croatia) to `ncid` and `ncid.conf`.
*   Added alternate date formats and separators.
*   Wrote a `ncid-tiny` module that became the basis for `ncid-alert`.
*   In general, helps with various NCID programs and documentation.

#### [Steve Limkemann](mailto:stevelim@wwnet.com)
*   Modified `ncidd` to output CID information quickly if a name is not   
    part of the Caller ID received.
*   Improved the `cidupdate` tool.
*   Improved `ncid's` GUI, by adding multiple features such as window  
    resizing and the ability to change font names and font sizes.
*   Added wakeup feature to `ncid` and wrote the `ncid-wakeup` module.
*   In general, helps with various NCID programs.

#### [Tod Cox](mailto:coxb@rice.edu)
*   Ported NCID to the Raspberry Pi running the Raspbian OS.
*   Helped make changes to `LCDncid` so it would run on the Raspberry Pi.
*   Made and purchased some LCD displays and got them working on the  
    Raspberry Pi using `LCDncid`. 

#### [Nicholas Riley](mailto:nriley@sabi.net)
*   Maintained `NCIDPop` for Mac OS X.

#### [Alexei Kosut](mailto:akosut@cs.stanford.edu)
*   Original developer of `NCIDPop` for Mac OS X and Windows.

#### New Feature Requests, Bug Reports, Testing Fixes, and Testing New features
> Adam 'Starblazer' Romberg  
  Andy Nunez  
  Andy Writter  
  Aron Green  
  Carl Johnson  
  Dan Lawrence  
  David LaPorte  
  Joe Nardone  
  Ken Appell  
  Lloyd Stahlbush  
  Mace Moneta  
  Matt Short  
  Michael Lasevich  
  Nicholas Davies  
  Paul Miller  
  Phil Fitzpatrick  
  Rick Matthews  
  Steve Forman  
  Troy Carpenter  
  Jonathan Wolf  
  Marko Koski-Vähälä  
  George Johnson  
  Steve Major  
  Charlie Heitzig  

#### Feedback On Working Modems
> Derek Huxley

## <a name="todo_top"></a>TODO

> [Table of Contents](#doc_top)

### TODO Lists

> * [TODO](#todo_definitely)
  * [Maybe](#todo_maybe)

### <a name="todo_definitely"></a>The TODO list (in no particular order)

> - Add graphics to view image of who is calling
> - Add ncid.exe to the Windows tray
> - Add support for PBX
> - Redo web site
> - Add a iax2 gateway
> - Add a GUI configuration program for the server, client, modules,
    and gateways
> - Create a Mac OS X installer
> - Add blacklist/whitelist support to wc2ncid gateway
> - Allow wc2ncid/wct to configure devices out-of-subnet
> - Allow client or gateway to tell server not to send history file
> - Allow clients to manually hangup calls using the server
> - Allow clients to tell an Android phone to hangup using the server
> - Allow clients to request the blacklist and whitelist files.

### <a name="todo_maybe"></a>The Maybe list (in no particular order)

> - Add ability to get name from address book.
> - Add ringtone support (NCIDpop and ncid-applet have ringtone support)
> - Add a Firefox module
> - Add SSL between server and client for secure use over Internet
> - Use separate ports for clients and gateways
> - Add SIP blocking and recording capability
> - Add a Modem On Hold feature or at least display the Caller ID
    during a modem data call
> - Add XBMC support
